*==========================================================================================
*** 1d_RMS_montlysales.do
***	Export total monthly sales at store level
*==========================================================================================

	args firstmodline lastmodline
	
	global firstmodline = `firstmodline'
	global lastmodline = `lastmodline'

*===========================================================================================
*** Directory Set-up	

*Set project directories	

	do ../../SetFilePaths.do
	
	global currentstep "$terminal/0b_dataimport"
	
*Set-up standard directories	
	global data "$currentstep/STATAData"	
	global output "$currentstep/STATAOutput"
	global logs "$currentstep/STATALogs"
	
*Set directory to data directory
	cd "$data"

*Directory for intermediate files
	cap mkdir ${data}/RMS_monthlysales
	
*===========================================================================================
*** Preliminary Set-up						

	clear
	set more off, perm
	set matsize 10000
	#delimit cr

*===========================================================================================
* Sub-programs
*===========================================================================================

capture prog drop RMS_storesales_chunk
prog define RMS_storesales_chunk
	
if 1==1{

	* load a full list of product modules to loop through
		use ${data}/productmodule_list_noncount.dta, clear
				// created in 0c_createproductids.do
			
			sort product_module_code	
			keep if _n >= ${firstmodline} & _n <= ${lastmodline}
			isid product_module_code
			levelsof product_module_code, local(modulelist)
	
		clear 
		save ${data}/RMS_monthlysales/store_monthlysales_${firstmodline}_${lastmodline}.dta, empty replace
		use ${data}/RMS_monthlysales/store_monthlysales_${firstmodline}_${lastmodline}.dta, clear
		
		* append together all modules to caculate store sales in each month
			local i = 1
			foreach p of local modulelist{
				foreach y of numlist 2006/2014{
					
					cap noisily append using ${RMSdata}/WorkingFiles/month_`p'_`y'.dta
							// created in 0a_dataconstruct/Code/1_createworkingfiles.do
					if _rc == 0 {
						bys store_code_uc year month: gen ttvalue = sum(value)
						bys store_code_uc year month (ttvalue): keep if _n == _N
						keep store_code_uc year month ttvalue
						rename ttvalue value
					}
					local i = `i'+1
				}
			}
				
		save ${data}/RMS_monthlysales/store_monthlysales_${firstmodline}_${lastmodline}.dta, replace

}
end

*===========================================================================================

cap prog drop RMS_storesales_agg
prog define RMS_storesales_agg

if 1==1{

	clear
	save ${data}/store_monthlysales.dta, empty replace
	use ${data}/store_monthlysales.dta, clear

	forv i = 1(50)1302{
		local j = `i' + 50 - 1 
		di "`i' -- `j'"	
		cap noisily append using ${data}/RMS_monthlysales/store_monthlysales_`i'_`j'.dta
			// created in subprogram RMS_storesales_chunk
	}

	bys store_code_uc year month: gen ttvalue = sum(value)
	bys store_code_uc year month (ttvalue): keep if _n == _N
	drop value
	rename ttvalue value
	save ${data}/store_monthlysales.dta, replace
	
}
end

*==================================================================================================
*==================================================================================================
**** Run programs

	if ${firstmodline} == 0 & ${lastmodline} == 0{
			RMS_storesales_agg
	}	
	else RMS_storesales_chunk

*==================================================================================================
*==================================================================================================
	

