function [data,hhdata,dist,draws,ids,T,J,B,sumJt,minmaxJt,micro,pca_pctexpl,nz,ncomp]=step0_datawork(env,modid,origmicro,time,sample,ns,simT,simJ,maxJTsize,maxT,outsidegoodscutoff,residinstr,pcacutoff)

   
    global jobid terminal
    
        disp(['data work for module ',num2str(modid)])   
        micro = origmicro;

%% Import or simulate data...
    if modid>0
        
    disp '%%%%%%%%%%%%%%%%%%%%%%%%%%%% Import data... %%%%%%%%%%%%%%%%%%%%%%%%%%%%'

      code=cd(strcat(terminal,'/1_dataprep/STATAOutput/dataMatLab_cbsa'));
     
        disp '% data (store data)...'
                % one observation for each market-product, sorted by market then by
                % product
                % data.mktid: raw identifiers for T markets (not 1 through T);
                % data.prodid: raw identifiers for J products (not 1 through J);
                % data.brandid: raw identifiers for B brands(not 1 through B);
                % data.Vjt: T*J vector of total product sales in each market;
                % data.x: T*J x K [number of characteristics (currently only price)];
                % data.Z: T*J x D [number of instruments (including exogenous, currently only price)];
                % data.sjt: data.vjt./totalsales(data.mktid);
                % data.outsidegoods60: 1/0 flag for whether the product is an
                    % outside good, i.e., with average sales less than the 60th percentile
                % only includes markets that sell the outside good and at least one non-outside good
                 filename= strcat('storecsv_',time,'/2012/outsidedef0/outside',outsidegoodscutoff,'/','/store_module',num2str(modid),'_data.csv')
                 data=dataset('File',filename);
                % specify main instrument, if not selected prior to import
                     try data.Z=data.Z2; end         %Z2 = same chains different DMAs; Z1 = same channel, different chains & different DMAs;       
                       if residinstr==1 || residinstr==3,
                            data=data(data.Z1>0,:);   % drop any observations where Z1 is set to zero - i.e., missing)
                            beta=[ones(size(data.Z1)) log(data.Z1)]\log(data.Z2)
                            data.Z = exp(log(data.Z2) - beta(1) - beta(2)*log(data.Z1)); 
                            if residinstr==3, data.Z=[data.Z2 data.Z]; end
                        end
                        if residinstr==2,   % OLS
                            data.Z = data.x; 
                        end
                        if residinstr==4,
                             data=data(data.Z1>0,:);   % drop any observations where Z1 is set to zero - i.e., missing)
                        end
                        try data.Z1=[]; end
                        try data.Z2=[]; end
                        
                   data.OG=data.outsidegoods;
                   data.outsidegoods=[];
                   data.x=log(data.X);
                   data.z=log(data.Z); 
                   data=data(data.sampleid>=sample,:);
                   data.sampleid=[];
                    
            disp '% hhdata (household data)...'
                % one observation for each market-transaction, sorted by market then by transaction
                % hhdata.mktid: market identifiers (not 1 through T) matches those from store data;
                % hhdata.hhid: household transaction subscripts (1...nhh) in each market
                % hhdata.selection: product selected - matches raw product identifiers (not 1 through J) from store data;
                % hhdata.lninc: household income
                % hhdata.units: number of units purchased by a household)
                % hhdata.w: hhdata.units/sum(hhdata.units)

                    try
                           hhdata=dataset('File', strcat('HHcsv_',time,'/2012/outsidedef0/outside',outsidegoodscutoff,'/','/HH_module',num2str(modid),'_data_outside.csv'));
                    catch 
                        warning('No household data found.  Resetting micro to zero. Creating dummy household data matrix.')
                        micro=0;
                        hhdata.mktid=0; hhdata.hhid=0; hhdata.selection=0; hhdata.lninc=0; hhdata.units=0; hhdata.w=0;
                        hhdata = struct2dataset(hhdata);
                    end
                   
            disp '% dist (parameters of income distribution in each city)...'
                 dist=dataset('File', strcat('storeincdist_',time,'.csv'),'Delimiter',',');
                 dist.Properties.VarNames{2} = 'freq';  
                    % one observation for each of T markets
                    % dist.store_code_uc /dist.fipscounty
                    % dist.`freq' (month, quarter, year, week)
                    % dist.mktid: market identifiers (not 1 through T) matches those from store data;
                    % dist.meanlninc: mean income
                    % dist.vlninc: variance of income
    
                save('-v7.3', strcat(terminal,'/3_estimation/3a_withinmodule/MATLAB/Data/dist_0_',time,'_',mkt,'.mat'), 'dist');
        
            % Market sample restrictions
                distdrop=[];
                distdrop = [distdrop; dist((dist.outlierdrop+(dist.vlninc<0)>0),:)];
                dist = dist((dist.outlierdrop+(dist.vlninc<0)==0),:);
                mktkeep=unique([dist.mktid],'rows');
                distmkts=dataset({mktkeep,'mktid'});
                data=join(data,distmkts,'Keys','mktid','Type','left');
                data=data(~isnan(data.mktid_right),:); % keep markets with non-missing income info
                data.mktid_right=[];
                data.Properties.VarNames{5} = 'mktid'; % rename mktid_left back
                try dist.outlierdrop=[]; catch; end
         
            cd(code)
    else
         disp '%%%%%%%%%%%%%%%%%%%%%%%%%%%% Simulate data... %%%%%%%%%%%%%%%%%%%%%%%%%%%%'
              theta_sim=[5; 0.1; 0.1]; % alpha_0, alpha_1, gamma;  
              [data, dist, param, hhdata]=step0ai_generatedata(theta_sim,simT,simJ,500,20);  
                    % (theta,T,J,ns,nhh) where ns = number of points
                    % from store inc distribution; nhh = number of
                    % simulated households in each market
              [data]=step0aii_cleansimulateddata(data);
              save('-v7.3',strcat(terminal,'/3_estimation/3a_withinmodule/MATLAB/Data/simdata.mat'), 'data', 'dist', 'hhdata', 'param');
    end
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Clean Data
    disp '%%%%%%%%%%%%%%%%%%%%%%%%%%%% Impose sample limits %%%%%%%%%%%%%%%%%%%%%%%%%%%%'

    if maxT>0,        
            disp(['%Keep random subsample of ',num2str(maxT),' out of ',num2str(size(unique(data.mktid),1)),' markets'])
            % first identify markets that we have household purchases in...
                uniquehhmkts=unique(hhdata.mktid);
                hhmkts=dataset({uniquehhmkts,'mkt'},{ones(size(uniquehhmkts,1),1),'inhh'});
                disp('number of markets we see households shopping in:')
                    size(uniquehhmkts,1)
                [uniquemkts,~,datamktpos]=unique(data.mktid);
                mktsales=accumarray(datamktpos,data.vjt);
                disp('number of markets in store data:')
                    size(uniquemkts,1)
                mkts=dataset({[uniquemkts mktsales],'mkt','sales'});
                mktdraws=join(mkts,hhmkts,'Type','leftouter','MergeKeys',true);
                    % data set of store data markets, with a variable (inhh) identifying
                    % whether we see households shopping in those markets
                mktdraws.inhh(isnan(mktdraws.inhh),:)=0;
                disp('number of markets in store data with households shopping in them:')
                    sum(mktdraws.inhh)
            % collapse data to the level that we are sampling at, sample
                    mktdraws.mktid=mktdraws.mkt;
                    mktdraws=join(mktdraws,dist,'mktid');
                    [uniquesampleby,~,samplebypos]=unique(mktdraws.sampleby);
                    samplebysales=accumarray(samplebypos,mktdraws.sales);
                    samplebyhhs=accumarray(samplebypos,mktdraws.inhh);
                    samplebymkts=accumarray(samplebypos,ones(size(mktdraws,1),1));
                    samplefrom=dataset({[uniquesampleby samplebysales samplebyhhs samplebymkts],'sampleby','sales','inhh','nmkts'}); 
            %  take "sample by" selections with households first and then, for remainder, random selection (with weights)
                    rng(max(1,modid),'twister'); % added 20170906 so that random set of markets is replicable
                    maxT = min(maxT,sum(samplefrom.nmkts));
                    nmktsneeded = maxT - sum(samplefrom.inhh.*samplefrom.nmkts);
                    if nmktsneeded>0,
                        samplefromnotinhh = samplefrom(samplefrom.inhh==0,:);
                        ntosample = min(size(samplefromnotinhh,1),nmktsneeded);
                        drawsrand = datasample(samplefromnotinhh,ntosample,1,'Replace',false,'Weights',samplefromnotinhh.sales);
                        keepdraws = cumsum(drawsrand.nmkts)<nmktsneeded;
                        keepdraws=[1; keepdraws(1:end-1)];
                        drawsrand(keepdraws==1,:);
                        samplebyset=[samplefrom.sampleby(samplefrom.inhh==1,1); drawsrand.sampleby(keepdraws==1,:)];
                    else,
                        samplefrominhh = samplefrom(samplefrom.inhh>0,:);
                        drawsrand = datasample(samplefrominhh,size(samplefrominhh,1),1,'Replace',false,'Weights',samplefrominhh.sales);
                        keepdraws = cumsum(drawsrand.nmkts)<maxT;
                        keepdraws=[1; keepdraws(1:end-1)];
                        drawsrand(keepdraws==1,:);
                        samplebyset=[drawsrand.sampleby(keepdraws==1,:)];
                    end
              % identify markets corresponding to sampled values
                    samplebyset=dataset({samplebyset,'sampleby'});
                    temp=join(mktdraws,samplebyset,'Type','inner','MergeKeys',true);
                    mktset=dataset({temp.mktid,'mktid'});

        disp(['%Keep only specified markets (N markets = ',num2str(size(mktset,1))])   
            dist=join(dist,mktset,'Type','inner','MergeKeys',true);
            data=join(data,mktset,'Type','inner','MergeKeys',true);
            data(1,:)
            if micro>0, 
                hhdata=join(hhdata,mktset,'Type','inner','MergeKeys',true);
                hhdata(1,:) 
            end
    end 
    
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
	[data, OGdata, hhdata, dist, micro]=step0b_alignidentifiers(data,hhdata,dist,micro); 
        % drop markets that don't sell any of the outside good(s) or a sufficient number of inside goods (currently 2)
        % accumulate sales data for outside good(s)
        % generate sequential product, brand, and market identifiers for remaining data
        % get household data for this set of products, brands, and markets
        % replaces micro = 0 if not enough households

    if origmicro~=micro 
        disp '... micro reset to 0 due to insufficient household data; exit estimation'
        return;
    end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% exit if few have too few markets with the non-outside good
	T=numel(unique(data.mktid(data.OG==0)));
	N=numel(data.mktid(data.OG==0));
	if T<5 & N==0,
		%export exitflag...
			code=cd(outputdir)
                results_exit=dataset({[modid,0,T,N],'modulenum','exitflag','T','N'});
                export(results_exit,'file',strcat('MATLABexit_mod',num2str(modid),'_micro',num2str(origmicro),'_',time,'outside',outsidegoodscutoff,'.txt'),'Delimiter',','); 
			cd(code)
		error('...too few markets with non-outside good (less than 5).')	
    end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Data prep
disp '%%%%%%%%%%%%%%%%%%%%%%%%%%%% Data prep %%%%%%%%%%%%%%%%%%%%%%%%%%%%%'          

disp '% Identify dimensions of data and create brand dummies...'
    [T] = max(data.mktid)
    [J] = max(data.prodid)
    [B] = max(data.brandid)
    Bdum=sparse([1:B],[1:B],1); 
    data.Bdums=Bdum(data.brandid,:);  
    
%****************************************************************************************************************************
disp '% Income data...'

disp 'Generate draws'
    
    draws=step0c_generatedraws(ns, dist);
        % one observation for each of ns simulated households in each of T markets
            % draws.lninc: T x ns - quadrature points
            % draws.w: ns x 1 weights - quadrature weights;
     
disp 'Difference income from log(37500) so that linear parameters roughly correspond to values from ivregression on market-level data'
	disp ' --> 37500 = approx mean income drawn from distributions for all markets'
    
    meanlninc=log(37500);
    
    data.vlninc=dist.vlninc(data.mktid); % load vlninc from store income *input* data
    draws.dmlnincbar = log(exp(draws.lninc)*draws.w)-meanlninc; %Calculate market-level expected *demeaned* income
    
    disp '... Calculate market-level mean demeaned income / expected demeaned income'
    % demeaned: subtract the across-market mean(in logged term)
        data.dmlnincbar = draws.dmlnincbar(data.mktid);        % this is the meanlninc calculated based on the data
        data.dmmktlninc=dist.meanlninc(data.mktid)-meanlninc;   
        
    disp '... final de-meaning'
        draws.lninc=draws.lninc-meanlninc; 
        hhdata.lninc=hhdata.lninc-meanlninc;
  
%****************************************************************************************************************************
disp '% Outside good...'

    disp 'Drop outside good observations '
       data=data(data.OG==0,:); 
        hhdata=hhdata(hhdata.selection>1,:);
        data.brandid = data.brandid-1;
        data.prodid = data.prodid-1;
        if micro>0, 
            hhdata.brandselection = hhdata.brandselection-1;
            hhdata.selection = hhdata.selection-1;
        end
    
    disp 'Account for outside share: difference data from market averages/difference from outside good data'
        data.OGrelx=data.x-OGdata.x(data.mktid,:); 
        data.relx=data.OGrelx;
        data.OGrelz=data.z-OGdata.z(data.mktid,:); 
        data.relz=data.OGrelz; 
        data.lnsjt=log(data.sjt);
        data.OGrellnsjt=log(data.sjt)-log(OGdata.sjt(data.mktid,:)); 
        data.rellnsjt=data.OGrellnsjt; 
   
%****************************************************************************************************************************
disp '% Instruments...'

disp 'Rescale price instruments'
		[data.relz,scalingfactors.z]=rescale(data.relz);
        disp(['...scaling factor: ',num2str(scalingfactors.z)])
        data.OGrelz = bsxfun(@times,scalingfactors.z,data.OGrelz);
        data.z = bsxfun(@times,scalingfactors.z,data.z);
        data.Z = exp(data.z);

disp 'Create brand dummies and pre-multiplier to extract betas from deltas'
    data.Bdums=data.Bdums(:,2:end);
    data.pre=((data.Bdums'*data.Bdums)\(data.Bdums'))';

    disp 'Calculate observation weights (based on market sales)'  
        try dist.wsale = dist.value/sum(double(dist.value));
        catch
            dist.wsale = ones(size(dist,1))/size(dist,1);
        end
    
    disp 'Instruments'
       K=[data.Bdums data.relz]; 
      data.relZ=[K bsxfun(@times,K,data.dmmktlninc) bsxfun(@times,K,(data.dmmktlninc.^2)) bsxfun(@times,K,data.vlninc)];
          
    if pcacutoff~=0
        
        disp 'Extract principal component representation of instruments'
        %   --> helps computationally (reducing variance of moments) & cuts down number of instruments
        
        [~, data.relZ,latent,~,pctexpl]=pca(full(data.relZ));
        
        if pcacutoff>0
            disp '... cutoffs based on percentage explained'
            ncomp=min(numel(pctexpl),sum(cumsum(pctexpl)<pcacutoff)+1)
        elseif pcacutoff <0,
            disp '... cutoffs based on eigenvalues'
            evcutoff = sum(latent)*(size(latent,1)^pcacutoff)
            ncomp=sum(latent>=evcutoff)
        end
        
        nz = size(data.relZ,2)
        data.relZ=data.relZ(:,1:ncomp);
        pca_pctexpl=sum(pctexpl(1:ncomp));
    
    else
        pca_pctexpl=0;							   
    end
       
%****************************************************************************************************************************
disp '% Extra datawork only required for NL estimation...'
        
        disp '% Identify dimensions of data...'
            sumJt = size(data.mktid,1);
    
        disp 'Generate subscript matrices to be used for summing across products within markets, across products within brands, etc.'
             subs = [repmat(data.mktid,[ns 1]) reshape(repmat(1:ns, [sumJt 1]),sumJt*ns, 1)  repmat(data.prodid,[ns 1]) repmat(data.brandid,[ns 1])];
                % subscripts: [market hh/draw product brand]
                    % mktid draw prodid brandid, 
                    % sorted by draw, mktid, then by product [2 1 3]
			subsmkt=[data.mktid data.prodid data.brandid];
                % subscripts: sorted by mktid, product

         disp 'Identify how many products in each market'
		    mktprodcount=accumarray(data.mktid,ones(size(data.mktid)));		% T x 1
			mktend=cumsum(mktprodcount)	;                                   % T x 1
			mktstart=[1; mktend(1:(end-1))+1];								% T x 1	
            minmaxJt = max(mktprodcount);

          if micro>0,
              disp 'Check how many households there are purchasing non-outside product in the data...'
                if numel(hhdata.mktid)==0, 
                        micro=0; 
                else
                    hhmktprods = sparse(data.mktid, data.prodid, data.prodid);
                    temp = sparse(data.mktid, data.prodid, ones(size(data.prodid)));
                        % sparse matrix with one row for each market, one column for
                        % each product identifier - each observation = 1 or product id when
                        % that product is observed in a given market
                    [~,~,hhmktprods] = find(hhmktprods(hhdata.mktid,:));
                    [~,~,hhmktmkts] = find(diag(hhdata.mktid)*temp(hhdata.mktid,:));
                    [~,~,hhmkthhs] = find(diag(hhdata.hhid)*temp(hhdata.mktid,:));
                    if numel(hhdata.mktid)==1,
                        hhsubs = sortrows([hhmktmkts' hhmkthhs' hhmktprods'],[3 1 2]);
                    else
                        hhsubs = sortrows([hhmktmkts hhmkthhs hhmktprods],[3 1 2]);
                    end
                    try assert(size(hhsubs,2)==3)
                    catch hhsubserror
                        size(hhmktmkts)
                        size(hhmkthhs)
                        size(hhmktprods)
                        hhdata
                        save('hhsubserror.mat')
                        rethrow(hhsubserror)
                    end
                end
                
            disp 'Identify products available in markets where we have households'
                hhmkts = unique(hhdata.mktid);   % markets where we have households
                prodsinhhmkts = ndSparse.build([data.mktid data.prodid], ones(size(data.mktid)));
                prodsinhhmkts = (sum(prodsinhhmkts(hhmkts,:),1)>0)';
              
            disp 'Identify products that households purchase'
                N_j = accumarray(hhdata.selection, hhdata.w,[],[],0);
                N_j = padarray(N_j,[J-1-size(N_j,1) 0],0,'post');
                prodshhspurchase = (N_j>0);

           disp '--> Subscripts of relevant products for household analysis'
                relhhprods = nonzeros((prodsinhhmkts.*prodshhspurchase.*[1:(J-1)]'));

          end
           
 	disp 'Group markets into sets that will require roughly equal amounts of RAM to compute constraint gradient'
			Tset=sparse(T,2);
            i=1; jt_lim=max(J,maxJTsize); Tsetstart=1; t=1;
			for t=1:T,
				subsmktset=subsmkt(subsmkt(:,1)>=Tsetstart & subsmkt(:,1)<=t,:);
                    mktmaxJt = size(unique(subsmktset(:,2)),1);
                subsmktsetnext=subsmkt(subsmkt(:,1)>=Tsetstart & subsmkt(:,1)<=(t+1),:);
                    mktmaxJtnext=size(unique(subsmktsetnext(:,2)),1);
                    mktTnext = (t-Tsetstart+2);
				if mktmaxJtnext*mktTnext>jt_lim || t==T,
					Tset(i,1)=Tsetstart;
					Tset(i,2)=t;
					Tset(i,3)=mktmaxJt;
					Tsetstart=t+1;
					i=i+1;
				end
            end
            
            disp('min market in set, max market in set, number of products represented in the market set:')
				Tset=full(Tset(Tset(:,1)>0,:));
                 ids=struct('sumJt',sumJt,'subs',subs,'subsmkt',subsmkt,...
                        'mktprodcount',mktprodcount,'mktstart',mktstart,'mktend',mktend,...
                        'Tsetmin',Tset(:,1),'Tsetmax',Tset(:,2),'nTset',size(Tset,1),'Tset',Tset); %structure array with counts and concordances to pass;
                  if micro>0, ids.hhsubs = hhsubs; ids.relhhprods = relhhprods; end

            disp 'Reset recursion limit to be greater than or equal to nTset:'
                set(0,'RecursionLimit', max(500,ids.nTset*2));
         

end
        
