function [data]=step0b_cleansimulateddata(data)
    
% Clean store data
	%generate market and intermediate product identifiers (1:T and 1:J)
		data.rawmkt=data.mktid;
		[T,~,data.mktid]=unique([data.rawmkt],'rows');
	   data.rawprod=data.prodid;
		[J,~,data.prodidint]=unique([data.rawprod],'rows');
	   data.rawbrand=data.brandid;
		[B,~,data.brandidint]=unique([data.rawbrand],'rows');
		unique([data.rawprod data.rawbrand], 'rows')
  
    %drop markets where we see crazy outliers
        
		%outlier prices within products
			meanx=accumarray(data.prodidint,data.x,[],@mean);
			sdx=(accumarray(data.prodidint,data.x,[],@var)).^0.5;
			meanx=meanx(data.prodidint); sdx=sdx(data.prodidint);
			data.rawx=data.x;
			outlier=abs(data.x-meanx)>5*sdx;
			dropmkt=accumarray(data.mktid,outlier);
			disp(['Markets with outlier prices within products: ' num2str(sum(dropmkt>0)) ' out of ' num2str(size(dropmkt,1)) ' total'])
			data=data(dropmkt(data.mktid)==0,:);
			[~,~,data.mktid]=unique([data.rawmkt],'rows');
		%outlier prices within module
			meanx=mean(data.x); sdx=(var(data.x)).^0.5;
			outlier=abs(data.x-meanx)>5*sdx;
			dropmkt=accumarray(data.mktid,outlier);
			disp(['Markets with outlier prices within modules: ' num2str(sum(dropmkt>0)) ' out of ' num2str(size(dropmkt,1)) ' total'])
			data=data(dropmkt(data.mktid)==0,:);
			[~,~,data.mktid]=unique([data.rawmkt],'rows');
			
	% identify products with low average sales shares...
	% merge these together as the outside good
	%(need to make sure that shares don't sum to one...
	% more difficult for markets with different product sets)
	% these will go into the outside good...
  
			keep=ones(max(data.prodidint),1);
	%
		%identify products with low sales shares 
		   prods=accumarray(data.prodidint,data.sjt)./accumarray(data.prodidint,ones(size(data.sjt)));
		   keep=keep.*(prods>prctile(prods,20));
	%
    %
		%identify products in the brand with the lowest average sales
		%across markets where it is sold
			brands=accumarray([data.mktid data.brandidint],data.sjt);
			brands=sum(brands)'./sum(brands>0)';
                brands
			brands=[[1:numel(brands)]' brands];
			brands=sortrows(brands,-2);
			dropbrand=brands(end,1);
			keepbrand=accumarray(data.prodidint,data.brandidint~=dropbrand);
			keep=keep.*(keepbrand>0); 
	%
    %{        
 		%identify outside good brand - brand with the largest average sales share in the markets where it is sold,
        %   conditional on having been sold in the greatest number of markets
        	brands=accumarray([data.mktid data.brandidint],data.sjt);
			nummkts=sum(brands>0)';
            avgsalesshare=sum(brands)'./nummkts;
			brands=[[1:numel(nummkts)]' nummkts avgsalesshare];
			brands=sortrows(brands,[2 3]);
			dropbrand=brands(end,1);
			keepbrand=accumarray(data.prodidint,data.brandidint~=dropbrand);
			keep=keep.*(keepbrand>0); 
     %}       
    %{
 		%identify outside good product - product with the largest average sales share in the markets where it is sold,
        %   conditional on having been sold in the greatest number of markets
        	prods=accumarray([data.mktid data.prodidint],data.sjt);
			nummkts=sum(prods>0)';
            avgsalesshare=sum(prods)'./nummkts;
			prods=[[1:numel(nummkts)]' nummkts avgsalesshare];
			prods=sortrows(prods,[2 3]);
			dropprod=prods(end,1);
			keep(dropprod)=0;
     %}
	
	%identify outside good observations 
		 data.OG=(keep(data.prodidint)==0);

	%sort
		data.rawx=[]; 
		data=sortrows(data,{'mktid' 'prodid'});

		disp(['Total markets remaining after data cleaning: ' num2str(max(data.mktid))])

end
        