function [out,f]=step1_microblp(nlestimate,checkgradients,objfuntest,alpha0start,alpha1start,gammastart,gridstartvalues)
       
		global env jobid bounds ids modid T J B ns micro time data hhdata wgtmat draws esta1 estg first scalingfactors
    
	sumJt = size(data.mktid,1);
	maxJt = max(data.prodid);
	ng1 = size(data.relZ,2);
    ng2 = micro;
    ng = ng1+ng2;
	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Estimation loops

% Matrices in which to keep estimates
    out.theta_lin=[]; out.beta_lin=[]; out.theta_lin_stderr=[];  out.beta_lin_stderr=[]; out.lintime=[]; 
    out.objfuntime=[]; out.gradientmatch=[];
    out.theta_hat=[];  out.beta_hat=[]; out.theta_stderr=[];  out.beta_stderr=[]; 
    out.delta=[]; out.modelstats=[]; out.V=[];
    out.effmodelstats=[]; out.efftheta_hat=[]; out.effdelta=[]; out.effbeta_hat=[];
    out.fitstats=[];
    
    m=1; % model counter
    
for estg=0:1:1 % gamma estimated flag
	for esta1=0:1:1 % alpha1 estimated flag
    
disp (['************************************************************************************'])
disp (['************************************************************************************'])
disp (['************************************************************************************'])
disp (['Model ' num2str(m) ': estalpha1 = ' num2str(esta1) ', estgamma = ' num2str(estg) ', micro moments? ' num2str(micro)])
        
		ntheta=1+esta1+estg;
        microrel=micro*(esta1+estg>0); % set micro moment flag to zero if the model doesn't have parameters that need these moments
 
disp (['************************************************************************************'])
disp (['************************************************************************************'])
   
disp '% Linear estimation for parameter starting values...'
            linstart=tic; theta_lin=step2_thetalin_twostep(data,esta1,estg); lintime=toc(linstart);
            beta_lin=theta_lin(1:end-1-esta1-estg); % extract beta estimates
            theta_lin=theta_lin(end-esta1-estg:end); % extract theta estimates (alpha0, alpha1, gamma)
            out.theta_lin=[out.theta_lin addzeros(theta_lin,esta1,estg)]; % output theta (adding zeros for when alpha1 and/or gamma aren't estimated)
            out.beta_lin=[out.beta_lin beta_lin(2:end)];  % output betas
            out.lintime=[out.lintime; lintime]; % output linear computing time
            if sum(isnan(theta_lin))>0, 
                theta_lin = theta_lin
                  error('linear estimates undefined')
            end             
        
disp (['************************************************************************************'])
disp (['************************************************************************************'])

    if objfuntest+checkgradients+nlestimate>0, 
        
         disp (['*****************************************************************'])
            disp '% Weighting matrix'
        	relZ = ndSparse(data.relZ);
            wgtmat = inv(relZ'*relZ);
            wgtmatscale = sum(sum(wgtmat));
            wgtmat = wgtmat/wgtmatscale;

            if micro>0,
                wgtmat=blkdiag(wgtmat,eye(ng2));
            end
             
        disp (['*****************************************************************'])
        disp '% Set bounds...'
            xlb=-Inf*ones(ntheta,1);       % lower bounds (maintained for delta and g parameters)
            xub=Inf*ones(ntheta,1);        % upperbounds (maintained for delta g parameters)
            xlb(1)=alpha0lb;                % alpha0 bounded below at 0.05
            xub(1)=alpha0ub;                % alpha0 bounded above by 100
            if esta1+estg>0, 
                xlb(2:(1+esta1+estg))=-bounds;
                xub(2:(1+esta1+estg))=bounds;
            end
    
		disp (['*****************************************************************'])
        disp '% Set starting values, identify rescaling factors and test objective/gradient functions...'
            disp '% default starting values are linear estimates...'
                theta0=theta_lin; 
                
        [x0,x0uncon,scalingfactors,extendedFeatures,objfuntime] = step3_startandrescale(theta0',alpha0start,alpha1start,gammastart,xub,xlb,esta1,estg);
        out.objfuntime=[out.objfuntime; objfuntime];

        nlstart=tic;
            step3a_alldeltas(x0);
        nltime=toc(nlstart)
        
    end
    
disp (['************************************************************************************'])
disp (['************************************************************************************'])
           
    if checkgradients==1,
       disp (['% Check Gradient Function...'])
            gradmatch=1;
            [~,analyticgrad,~,~,analyticdgdtheta]=step4a_gmmobjective(x0);
            analyticgrad=full(analyticgrad)
            numgrad=jacobianest(@funobj,x0)'
            max(max((numgrad-analyticgrad)))
              try 
                    assert (max(max((numgrad-analyticgrad)))<1e-6),
                    disp '--> check passed';
                catch checkerror
                    jacobianmatch=0;
                    disp '!!!! difference between numeric and analytic > 1e-6 !!!!'
                    numdgdtheta=jacobianest(@fung,x0);
					size(analyticdgdtheta)
					size(numdgdtheta)
                    full([numdgdtheta analyticdgdtheta'])
                    myDerivCheck(@step4a_gmmobjective,x0,1e-5) 
              end       
          
      % output results from gradient checks:
        gradientmatch=[modid micro estg esta1 microrel gradmatch ]
        out.gradientmatch=[out.gradientmatch; gradientmatch];
    end

disp (['************************************************************************************'])
disp (['************************************************************************************'])

    if nlestimate>0,
  
        disp (['% Non-linear estimation...'])    
        
		     op = optimset('DerivativeCheck','off',...
				'FinDiffType','central','Display','iter-detailed',... 
				'GradConstr','on','GradObj','on','TolCon',1E-6,'TolFun',1E-6,'TolX',1E-6); 
				
		disp '% First-stage estimation'
			[theta_hat,fval_rep,exitflag,output,lambdaout,gradout,hessianout] = ...
                knitromatlab(@step4a_gmmobjective,x0,[],[],[],[],...
                xlb,xub,[],extendedFeatures,op,'knitroOptions2.opt');

           ms_oldexit=0;
            if gridstartvalues==1,
                if exitflag<0 || (sum(abs(log(xub./theta_hat))<0.03) + sum(abs(log(xlb./theta_hat))<0.03) > 0), 
                    ms_oldexit=exitflag;
                    disp (['*****************************************************************'])
                    disp (['*****************************************************************'])
                    disp '% Trying with a grid of starting values...'
                        a0base=1; a0facmax=4; results=[];
                        if esta1==1, a1base=4; a1facmax=4; else, a1base=0; a1facmax=0; end 
                        if estg==1, gbase=1.5; gfacmax=1.5; else, gbase=0; gfacmax=0; end % changed from -4 to 4 on 10/9
                        for a0fac=0:1:a0facmax, 
                            for a1fac=0:1:a1facmax,
                                for gfac=0:1:gfacmax,
                                   if exitflag==0 & (sum(abs(log(xub./theta_hat))<0.03) + sum(abs(log(xlb./theta_hat))<0.03) == 0), continue; end
                                   a0=a0base*(2^a0fac);
                                   a1=a1base-2*a1fac;
                                   g=gbase-0.5*gfac;
                                   theta_in=a0; 
                                   if esta1==1, theta_in=[theta_in a1]; end 
                                   if estg==1, theta_in=[theta_in g]; end
                                   [a0 a1 g]
                                   [x0,x0uncon,scalingfactors,extendedFeatures] = step3_startandrescale(theta_in,alpha0start,alpha1start,gammastart,xub,xlb,esta1,estg,1);
                                        % final argument indicates that this is grid search procedure - so ignore invalid starting values 
                                   if numel(x0)>0,
                                    [theta_hat,fval_rep,exitflag,output,lambdaout,gradout,hessianout] = ...
                                            knitromatlab(@step4a_gmmobjective,x0,[],[],[],[],...
                                            xlb,xub,[],extendedFeatures,op,'knitroOptions2.opt');
                                    results=[results; a0 a1 g exitflag x0(1:ntheta)'*scalingfactors.theta theta_hat(1:ntheta)'];
                                    [theta_hat xub xlb]
                                   end
                                end
                            end
                        end
                end
            end
            
        disp '% Calculate efficient weighting matrix for moment constraints...'
            [~,~,~,~,~,~,g]=step4a_gmmobjective(theta_hat);
            wgtmat=inv(full((g * g')))/size(data.relZ,1); 
            wgtmatscale=size(data.relZ,1); 

        disp '% Re-run with efficient weighting matrix...'
           [x0,x0uncon,scalingfactors,extendedFeatures] = step3_startandrescale(theta_hat',alpha0start,alpha1start,gammastart,xub,xlb,esta1,estg,1);
                            % final argument indicates that this is grid search procedure - so ignore invalid starting values 

            [theta_hat,fval_rep,exitflag,output,lambda] = ...
                knitromatlab(@step4a_gmmobjective,x0,[],[],[],[],...
                xlb,xub,[],extendedFeatures,op,'knitroOptions2.opt');  

        disp '%Output stats for model selection...'
            out.modelstats=[out.modelstats; modid micro esta1 estg microrel fval_rep exitflag output.firstorderopt output.iterations ms_oldexit];

        disp '%Output estimates...'
            out.theta_hat=[out.theta_hat nltheta];  
            nldelta = step3a_alldeltas(theta_hat);
            out.delta=[out.delta nldelta];
            out.beta_hat=[out.beta_hat data.pre'*nldelta];

        disp '%Calculate standard errors...' 
           [stderr, V, fitstats]=serr(@step4a_gmmobjective,theta_hat,data,microrel,wgtmat,wgtmatscale);
            out.theta_stderr=[out.theta_stderr addzeros(stderr(1:(1+esta1+estg)),esta1,estg)];
            out.beta_stderr=[out.beta_stderr stderr((2+esta1+estg):end)];
            size(out.fitstats)
            if esta1+estg==0, out.fitstats=[micro esta1 estg fitstats];
            else, out.fitstats=[out.fitstats; micro esta1 estg fitstats]; end
            V = addzerostwoway(full(V),esta1,estg);
            if m==1, out.V=[ones(size(V,1),1)*[esta1,estg,fval_rep] V];
            else out.V=[out.V; ones(size(V,1),1)*[esta1,estg,fval_rep] V]; end

        disp '%Calculate standard errors for linear estimates...' 
            [stderr, V, fitstats]=serr(@step4a_gmmobjective, x0uncon, data, microrel,wgtmat,wgtmatscale);
            out.theta_lin_stderr=[out.theta_lin_stderr addzeros(stderr(1:(1+esta1+estg)),esta1,estg)];
            out.beta_lin_stderr=[out.beta_lin_stderr stderr((2+esta1+estg):end)];

        disp(['[Linear  Estimates + Std Errors; Non-Linear Estimates + Std Errors]']);   
            theta_comp=full([out.theta_lin(:,m) out.theta_lin_stderr(:,m) out.theta_hat(:,m) out.theta_stderr(:,m)])
            beta_comp=full([out.beta_lin(:,m) out.beta_lin_stderr(:,m) out.beta_hat(:,m)  out.beta_stderr(:,m)]) 
 
    end % end nlestimate>0

    m=m+1;

end % end esta1
end % end estg
    
disp (['************************************************************************************'])
disp (['************************************************************************************'])

end    %EOC

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Functions
    
% calculate standard errors
    function [stderror,V,fitstats]=serr(func, theta, data, microrel,wgtmat,wgtmatscale)     
		first=1; 	
        if microrel>0, 
                [~, ~, ~, dgdtheta, ~, xi, g, dg2dtheta, ...
            sharebeta_j, expdiff, dg3dtheta, g2_j, g3_h, ...
            dgddelta, dg2ddelta, dg3ddelta, g2_t, g3_t, N2, N2_t] = func(theta);
        else
            [~, ~, ~, dgdtheta, ~, xi, g, ~, ...
            sharebeta_j, expdiff, ~, ~, ~, ...
            dgddelta, ~, ~, ~, ~, ~, ~] = func(theta);
        end
        if numel(dgdtheta)==0,
			stderror=-99*ones(size(theta)); 
			V=-99*ones(numel(theta));
            fitstats=-99*ones(1,10);
		else
			n1=numel(xi);
			f1_jt = bsxfun(@times,data.relZ,xi);
			Vtemp = (1/n1) * (f1_jt' * f1_jt);			  % (L x L)
			dgdbeta = -data.relZ' * data.Bdums;     % (L x sumJt) --> (L x B)
			F = (1/n1) * [dgdtheta dgdbeta];      % (sumJt x L)' * (L x ntheta+B) --> L x (ntheta + B)
			V=inv(F'*(Vtemp\F));     
            stderror=(diag(V)./(n1)).^(1/2);  
			if microrel>0, 
				F = [F; [dg2dtheta' zeros(1,size(data.Bdums,2))]; [dg3dtheta' zeros(1,size(data.Bdums,2))]]; 
				% dg2dbeta and dg3dbeta are zeros since only delta, not beta enters the share calculation 
					% [(L + nmicro) x (ntheta + B)]
				Vtemp = padarray(Vtemp,[2 2],0,'post');
				Vtemp(end-1,end-1)= (g2_j' * g2_j)/numel(g2_j);
				Vtemp(end,end)= (g3_h' * g3_h)/numel(g3_h);
                V=inv(F'*(Vtemp\F));     
                stderror=(diag(full(V))./(n1+numel(g2_j)+numel(g3_h))).^(1/2);  
            end
            disp '% Updated model selection stats'
                N=numel(xi);
                Lmacro=size(data.relZ,2);
                gsum=(data.relZ'*xi)/N;
                macroJeff = N*(gsum')*Vtemp(1:Lmacro,1:Lmacro)*(gsum);
                macroJest = N*(gsum'/N)*(wgtmat(1:Lmacro,1:Lmacro)*wgtmatscale/N)*(gsum/N);
                 if microrel>0, 
                    g2sum = sum(g2_j); 
                    g3sum = sum(g3_h); N3 = N2; 
                    Jeff = N*([gsum; g2sum; g3sum])'*Vtemp*([gsum; g2sum; g3sum]);
                else,
                    Jeff = macroJeff; g2sum = 0; N2 = 0; g3sum = 0; N3 = 0;
                end
                fitstats = [microrel Jeff macroJeff macroJest N wgtmatscale g2sum N2 g3sum N3];  
		end
    end
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       
% add in zeros into parameter matrix for fixed parameters
    function [theta_hat_out]=addzeros(theta_in,esta1,estg)       
		if numel(theta_in)>1+esta1+estg, tailtheta=theta_in((2+esta1+estg):end); else, tailtheta=[]; end
        theta_hat_out=[theta_in(1); 0; 0; tailtheta];
        if esta1==1, theta_hat_out(2)=theta_in(2); end
        if estg==1, theta_hat_out(3)=theta_in(2+esta1); end      
    end

% add in zeros into var-covar matrix for fixed parameters
    function [V]=addzerostwoway(V_in,esta1,estg)    

        V=V_in;
        if esta1==0, 
			K=size(V,1);
            V=padarray(V,[1 1],0,'post');
			V=sortrows([[1 3:K+1 2]', V],1); V=V(:,2:end);
			V=sortrows([[1 3:K+1 2]; V]',1)'; V=V(2:end,:);
        end
        if estg==0, 
			K=size(V,1);
			V=padarray(V,[1 1],0,'post');
			V=sortrows([[1:2 4:K+1 3]', V],1); V=V(:,2:end);
			V=sortrows([[1:2 4:K+1 3]; V]',1)'; V=V(2:end,:);  
        end
    end
     
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% check the analytic derivative
     function myDerivCheck(func,thetabase,deps)
        first=1; 
        disp(['Derivative Check:']);
            [fval,gval,ddeltadtheta,dxidtheta,dgdtheta,gradstar,deltaomegainv,deltaxi,deltag] = finite_difference(func,thetabase,deps);
            disp(['[Analytic; Numeric]']); disp(num2str([gval gradstar]));
            
        disp(['Jacobian Check:']);
            absdiff=abs(dxidtheta-deltaxi); [maxabsdiff,subJ]=sort(max(absdiff,[],2),1,'descend'); maxJ=min(size(subJ,1),10);
            disp (['Number of observations for which numerical deltaxi ~= analytic:']); sum(maxabsdiff>0.00001)
            disp (['[Numerical deltaxi; Analytic deltaxi (Jacobian); Numerical deltaomegainv] (10 worst obs):'])
               full([dxidtheta(subJ(1:maxJ),:) deltaxi(subJ(1:maxJ),:) ddeltadtheta(subJ(1:maxJ),:)  deltaomegainv(subJ(1:maxJ),:)])
            disp (['[Numerical deltaxi; Analytic deltaxi (Jacobian)]:'])   
               full([dgdtheta' deltag])
      
     end
 
 % calculate the finite difference gradient and Jacobian
    function [fval,gval,ddeltadtheta,dxidtheta,dgdtheta,gradstar,deltaomegainv,deltaxi,deltag]=finite_difference(func,thetabase,deps)
		first=1; 
        [fval,gval,ddeltadtheta,dxidtheta,dgdtheta,~,~,~] = func(thetabase);
        gradstar = zeros(length(thetabase),length(fval));
        for z=1:length(thetabase)
          thetastarA = thetabase;
          thetastarB = thetabase;
          thetastarA(z) = thetastarA(z) + deps;
          thetastarB(z) = thetastarB(z) - deps;
          [fA,~,~,~,~,deltaA,xiA,gA]=func(thetastarA);
          [fB,~,~,~,~,deltaB,xiB,gB]=func(thetastarB);
          gradstar(z,:) = (fA - fB)/(2*deps);
          deltaomegainv(:,z) = (deltaA-deltaB)/(2*deps);
          deltaxi(:,z) = (xiA-xiB)/(2*deps);
          deltag(:,z) = (gA-gB)/(2*deps);
        end
    end
        
% just objective
        function [b] = funobj(x)
		
			[b,~] = step4a_gmmobjective(x);
			
        end

% just g
        function [b] = fung(x)
		
			[~,~,~,~,~,~,~,b] = step4a_gmmobjective(x);
			
        end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

