% this estimates parameters in two step procedure
    function [thetalin_twostep] = step2_thetalin_twostep(data,esta1,estg)

        % extract variables data 
            relx=data.OGrelx; Bdums=data.Bdums; rellnsjt=data.OGrellnsjt;   
            relz=data.OGrelz; 
                
       % RHS variables, instruments, and weighting matrix
            relX=[Bdums relx]; 
            dmlninc = data.dmlnincbar;
            relZ=[Bdums relz];
            relA=inv(full(relZ'*relZ)); 
         
        % Step 1: log-logit (assuming mean inc)
            [ivest,~]=ivregression(rellnsjt,relX,relZ,relA)
            beta=[0; ivest(1:end-1)];
            alpha0=-ivest(end);
            beta=beta/alpha0;
         
        % Step 2: regression of psi_hat (lns-deltahat) against linear terms
        % in mu ((gamma)*alpha0*betalninc, (alpha1)*(betalninc-lnplninc), (alpha1*gamma)*betalninc^2)
        disp('Note: even beta for simulated first product is non-zero because:')
        disp(' (i) it is not the quality of the original outside products, but the quality of the combined outside product, which has a large share because it combines various products')
        disp(' (ii) the lowest sales share brand in either the simulated or the actual data might have a very high price, so low sales in spite of high quality.')
			if esta1==0 && estg==0, 
                thetalin_twostep=[beta; alpha0]
            else 
                betahat=Bdums*beta(2:end);
				rellnsjt2=rellnsjt-(betahat-relx)*alpha0;
				if esta1+estg==2 
					relX2=[bsxfun(@times,betahat*alpha0,dmlninc) bsxfun(@times,(betahat-data.relx),dmlninc) bsxfun(@times,betahat,(dmlninc.^2))];
                    relZ2=[bsxfun(@times,betahat*alpha0,dmlninc) bsxfun(@times,repmat(betahat,1,size(data.Z,2))-data.Z,dmlninc) bsxfun(@times,betahat,(dmlninc.^2))];
                    relA2 = inv(full(relZ2'*relZ2)); 
					ivest2=ivregression(rellnsjt2,relX2,relZ2,relA2)
					gamma=ivest2(1); alpha1=ivest2(2);
					thetalin_twostep=[beta; alpha0; alpha1; gamma]
				else
					if esta1==1 	
						relX2=[bsxfun(@times,(betahat-data.relx),dmlninc)]; 
                        relZ2=[bsxfun(@times,repmat(betahat,1,size(data.Z,2))-data.Z,dmlninc)];
                        relA2 = inv(full(relZ2'*relZ2)); 
						ivest2=ivregression(rellnsjt2,relX2,relZ2,relA2)
						alpha1=ivest2(1); 
						thetalin_twostep=[beta; alpha0; alpha1]
					end
					if estg==1 % model 3
						relX2=[bsxfun(@times,betahat*alpha0,dmlninc)]; 
                        relZ2=[bsxfun(@times,betahat*alpha0,dmlninc)];
                        relA2 = inv(full(relZ2'*relZ2)); 
						ivest2=ivregression(rellnsjt2,relX2,relZ2,relA2)
						gamma=ivest2(1); 
						thetalin_twostep=[beta; alpha0; gamma]
					end
				end
			end
			
    end
    
    
        
    
    
    
    