% starting values and rescaling
    function [x0,x0uncon,scalingfactors,extendedFeatures,objfuntime] = step3_startandrescale(theta_in,alpha0start,alpha1start,gammastart,xub,xlb,esta1,estg,grid)
 
		global modid micro data draws scalingfactors
     
        ntheta=1+esta1+estg;
        sumJt = size(data.mktid,1);
        if nargin<10, grid=0; end
        
              theta0 = real(theta_in)';
               
           if isequal(theta0,max(min(theta0,xub(1:ntheta,:)),xlb(1:ntheta,:)))==0, 
                disp '... input theta outside bounds'
                if grid==1, x0=[]; x0uncon=[]; extendedFeatures=[]; objfuntime=[]; return; end
                    disp ' - re-set to exogenous starting values, set deltas to linear values'    
                        alpha0=alpha0start; alpha1=0; gamma=0; theta0=alpha0;
                        if esta1==1, alpha1 = alpha1start; theta0=[theta0; alpha1]; end 
                        if estg==1, gamma = gammastart; theta0=[theta0; gamma]; end 
            else
                if esta1==1 & ((theta0(1)+theta0(2)*max(max(draws.lninc))<0.05) || (theta0(1)+theta0(2)*min(min(draws.lninc))<0.05)),
                    disp '... alpha1 linear estimate outside reasonable bounds'
                    if grid==1, x0=[]; x0uncon=[]; extendedFeatures=[]; objfuntime=[]; return; end
                        disp '- reset starting value:'
                            theta0(2) = min((0.05 - theta0(1))/max(max(draws.lninc)),(0.05 - theta0(1))/min(min(draws.lninc))); 
                end
            end
	
        disp (['*****************************************************************'])
        disp '% Identify appropriate rescaling factors & rescale starting values)'
			   [theta0,scalingfactors.theta]=rescale(theta0);
                scalingvec = [scalingfactors.theta.*ones(ntheta,1)];
                xub = xub./scalingvec;      % rescale upper bounds
                xlb = xlb./scalingvec;      % rescale lower bounds                
                
            disp '... set non-theta starting values to be within bounds'
                x0uncon = theta0; 
                x0 = max(min(x0uncon,xub),xlb);    % impost upper and lower bounds values              
             
            disp '... Knitro parameter scaling factors'
                extendedFeatures.xScaleFactors = ones(size(x0));
                extendedFeatures.xScaleCenters = zeros(size(x0));
                            
        disp (['************************************************************************************'])
        disp '% Time objective and constraint functions and determine Knitro internal rescaling factors'
            objstart=tic;    
                [f,grad_f]=step4a_gmmobjective(x0)
            objtime=toc(objstart);
                if sum(sum(isnan(f)))+sum(sum(isnan(grad_f)))>0, 
                        f;
                        grad_f;
                        warning('obj function undefined at starting value')
                end
                
            disp '... Knitro obj function scaling'
                extendedFeatures.objScaleFactor=1/f;    
	
            objfuntime=[modid micro estg esta1 objtime floor(full(f)/1e+8)];
           
    end        