function [out]=step3c_cons_s_par(mktdelta,theta,mktdata,mktidssubs,mktidssubsmkt,...
            mktdrawslninc,mktdrawsw,nargs,esta1,estg,sumJt,ntheta,...
			ns,minT,maxT,mktstart,mktend);
	% calculation of con_s and dsddelta/dsdtheta...

	% extract parameters
	   alpha0 = theta(1);
	   gamma = 0; alpha1 = 0;
	   if esta1==1,
		   alpha1 = theta(2); 
		   if estg==1, gamma = theta(3); end
	   else
		   if estg==1, gamma = theta(2); end 
       end
  
	%switch market identifier to be relative to minimum market included   
		mktsumJt = size(mktdata.mktid,1);
		minmkt=min(mktdata.mktid);
		mktdata.mktid=mktdata.mktid-minmkt+1;
		mktidssubs(:,1)=mktidssubs(:,1)-minmkt+1;
		mktidssubsmkt(:,1)=mktidssubsmkt(:,1)-minmkt+1;	
		mktT = max(mktdata.mktid);
	        
    %switch product identifier to be a 1:J count within each of these markets
        [~,~,mktdata.newprodid]=unique([mktdata.mktid mktdata.prodid], 'rows');
        minprodinmkt=accumarray(mktdata.mktid,mktdata.newprodid,[],@min);
        mktdata.newprodid=1+mktdata.newprodid-minprodinmkt(mktdata.mktid);
		mktmaxJt = max(mktdata.newprodid);
        mktprods=unique([mktdata.mktid mktdata.prodid mktdata.newprodid], 'rows');
		mktprods=ndSparse.build(mktprods(:,1:2),mktprods(:,3));
        mktidssubs(:,3)=mktprods(sub2ind(size(mktprods),mktidssubs(:,1),mktidssubs(:,3)));
		mktidssubsmkt(:,2)=mktdata.newprodid;
        mktdata.prodid=mktdata.newprodid; mktdata.newprodid=[];
            %ordered by market then by product within market
        
    %compute purchase probabilities
        lninc=mktdrawslninc;                     % T x ns
        alphai= alpha0+alpha1*lninc;            % T x ns
        gammai= 1+gamma*lninc;                  % T x ns
        ag=alphai.*gammai;                      % T x ns 	
        u=reshape(bsxfun(@times,mktdelta,ag(mktdata.mktid,:))...
					-bsxfun(@times,mktdata.relx,alphai(mktdata.mktid,:)),[],1);
        %  implied utility (up to idiosyncratic logit error), sorted by draw then market then product
        %   sumJt x ns --> sumJt*ns x 1 (with mkt, draw, product subscripts in mktidssubs)
 
        mktids=struct('subs',mktidssubs,'subsmkt',mktidssubsmkt,'N',mktsumJt,'maxJt',mktmaxJt);
				%structure array with counts and concordances to pass;
 
        pijt = step3ci_rc_shares_multmkt(u,mktids); % compute purchase probabilities
            % sorted by draw, market, then product (as are mktidssubs)

        try
            pjt = sum(ndSparse.build(mktidssubs(:,[1 3 2]),pijt.*mktdrawsw(mktidssubs(:,2),:)),3);
        catch pjterror
            size(mktidssubs(:,[1 3 2]))
            size(pijt)
            size(mktdrawsw(mktidssubs(:,2),:))
            size(pijt.*mktdrawsw(mktidssubs(:,2),:))
            size(u)
            save('step3bi_cons_s_par_error.mat')
            rethrow(pjterror)
        end
			% T x maxJt x ns --> T x maxJt 
             
   % constraints on mean utilities
        if nargs<2,[out.con_s]=step3cii_Fdelta_par(pijt,pjt,ag,mktdata.rellnsjt,mktdrawsw,mktids,minT,maxT,1); 
        else [out.con_s,out.dFdmktdelta]=step3cii_Fdelta_par(pijt,pjt,ag,mktdata.rellnsjt,mktdrawsw,mktids,minT,maxT,2); end  
          	      
    % gradients
        % dFddelta 
            out.dFddelta = sparse(mktsumJt,sumJt);
            out.dFddelta(1:mktsumJt,min(mktstart):max(mktend)) = out.dFdmktdelta;	% [mktsumJt x sumJt] 
            
    if nargs>2	
            	
        % dsdtheta: derivative of simulated market share with respect to theta
            z=1;
            dsdtheta_vec = zeros(mktsumJt*ntheta,1);
            dfdtheta=reshape(bsxfun(@minus,bsxfun(@times,mktdelta,gammai(mktdata.mktid,:)),mktdata.relx),mktsumJt*ns,1);
                % mktsumJt*ns x 1
            if esta1==1, z=z+1; dfdtheta(:,:,z)=reshape(lninc(mktdata.mktid,:),mktsumJt*ns,1).*dfdtheta(:,:,1); end; % mktsumJt*ns x 1
            if estg==1, z=z+1; dfdtheta(:,:,z)=reshape(bsxfun(@times,mktdelta,lninc(mktdata.mktid,:).*alphai(mktdata.mktid,:)),mktsumJt*ns,1); end; % mktsumJt*ns x 1
            for z=1:ntheta
                x1=dfdtheta(:,:,z).* pijt;
                    % mktsumJt*ns x 1: share_ijt*dfdtheta2 (x_jkt v_ik) in standard BLP
                x2=accumarray(mktidssubs(:,1:2),x1);
                    % T x ns: sum_j(share_ijt*x_jk) across products for each draw in each market
                x3=reshape(dfdtheta(:,:,z),mktsumJt,ns) - x2(mktdata.mktid,:);
                    % mktsumJt x ns: x_jk - sum_j(share_ijt*x_jk)
                dsdtheta_vec(1+(z-1)*mktsumJt:z*mktsumJt)=sum(bsxfun(@times,reshape(pijt,mktsumJt,ns).*x3,mktdrawsw'),2); 
                    % share_ijt*(x_jk - sum_j(share_ijt*x_jk))*v_ik*w_i
            end 
			coords=[repmat(mktidssubsmkt(:,1),ntheta,1) reshape(repmat([1:ntheta],mktsumJt,1),[],1) repmat(mktidssubsmkt(:,2),ntheta,1)];
            dsdtheta=ndSparse.build(coords,dsdtheta_vec); % T x size(theta) x maxJt
			clearvars dsdtheta_vec
			
            if sum(sum(isnan(dsdtheta)))
                disp('*******************************************')
                disp('...dsdtheta contains nan values.')
                size(dsdtheta)
				dsdtheta(1:max(size(dsdtheta,1),20),:,1:max(size(dsdtheta,3),20))
                return
            end
		
        % dFdtheta ([T x ntheta x maxJt])
			dlnsdtheta = bsxfun(@rdivide,dsdtheta,permute(pjt,[1 3 2]));	% [T x ntheta x maxJt]  
            dlns0dtheta = bsxfun(@rdivide,-sum(dsdtheta,3),1-sum(pjt,2));	% [T x ntheta] 
            dFdtheta = bsxfun(@minus,dlnsdtheta,dlns0dtheta); % [T x ntheta x maxJt] 
                clearvars dsdtheta dlns0dtheta dlnsdtheta pjt
            dFdtheta = ndReshape(permute(dFdtheta,[3 1 2]),mktmaxJt*mktT,ntheta);		
                % [maxJt*T x ntheta] ordered by market then by product
            mktsubsvec = (mktidssubsmkt(:,1)-1)*max(mktidssubsmkt(:,2))+mktidssubsmkt(:,2);	%
            out.dFdtheta = dFdtheta(mktsubsvec,:);	% [sumJt x ntheta] 
                     % dFdelta/dtheta = d(stilde-stildeobserved)/dtheta = dstilde/dtheta
                    % [dSdtheta2, dSddelta, zeros(numProdsTotal,ng)];

         
    end % end of nargs>2
       
        
end %EOC
