% this computes the shares for multiple markets
    function [pijt]=step3ci_rc_shares_multmkt(u,mktids)
    % pijt: the individual choice probabilities 
    
    % extract concordances
        subs=mktids.subs; subsmkt=mktids.subsmkt;
            % subs is [ mkt hh/draw prod ] ids sorted by hh/draw, market, then product 
            %   --> one product for each available in the market for macro data
            %   --> one selection for each hh/mkt for micro data (altered
            %   below to include one product for each available in the
            %   markets where households are below)
            % subsmkt is [ mkt prod brand ] ids sorted by market then product

    % useful counts
        T=max(subsmkt(:,1)); 
        ns = full(max(subs(:,2))); 
        maxJt = max(subsmkt(:,2));

   % permute matrix input of mean utility for micro moments...   
        reshapeout=0;
        if ndims(u)>2,
            % u is nhh/draws x T x maxJt 
            u = permute(u,[2 1 3]); % --> T x nhh/draws x maxJt to match subs
            subsmkt_mat = ndSparse.build([subsmkt(:,[1 1 2])],ones(size(subsmkt,1),1)); % T x T x maxJt 
                % --> which products are in which markets
            uniquehhmktsubs = unique(full(subs(:,[1:2])),'rows'); % vector of markets for each household
                % --> which households are in which markets
            subs_mat = permute(subsmkt_mat(uniquehhmktsubs(:,1),:,:),[2 1 3]); % nhh x T x maxJt --> T x nhh x maxJt
                % --> which products are in the markets that households are in
            subs_vec = find(subs_mat);
            [i,j,k] = ind2sub(size(u),subs_vec);
            if size(i,1)==1, subs = [i', j', k'];
            else, subs = [i,j,k]; end
                % --> [mkt hh prod] subscripts for new u - which is a
                % vector with one observation for every product in each
                % household-market
            u = reshape(sparse2d(u(subs_vec)),[],1); % T x nhh x maxJt --> [sum_hh,t(Jt),1] one obs for every product in each household-market
            reshapeout=1;
        % u is now sum_hh,t(Jt) or sum_ns,t(Jt)
        end

    % for macro moments (and, now micro moments)...
        % u is sorted by draw then by market then by product, i.e., all obs for draw1 come before all obs for draw2, etc.
        % within each draw, all obs for market 1 come before all obs for market 2, etc.

     % rescale utils by max in each market (scaling factor drops out in calculating probability)
        try mmax=accumarray(subs(:,1:2),u,[T ns],@max); %m=zeros([T ns]); % % T x ns
        catch me
            disp('Hit error #1 inner...')
            subsmkt
            subsmkt_mat
            uniquehhmktsubs
            subs_mat
            subs_vec
            mktids.subs
            subs
            [ns T maxJt]
            numel(size(u))
            ndims(u)
            size(u)
            size(u,1)
            size(subs,1)
            assert((size(u,1)==size(subs,1)))
            rethrow(me)     
        end
        m=mmax;
           % for macro moments alone, fine to only adjust downwards by mmax 
           
       % for micro moments, if concerned with getting expected purchase
       % probability = 0 then:
           %mmin=accumarray(subs(:,1:2),u,[T ns],@min); %m=zeros([T ns]); % % T x ns
            %m=(mmax>abs(mmin)).*(mmax-700) + (mmax<=abs(mmin)).*(mmin+700); 
            % if max>abs(min) shift downwards by max - 700, else shift upwards by - min + 700
            % allowing for the resulting max or min to be either -700 or +700.
            
        mlong = reshape(m,T*ns,1);
        utils=exp(u-mlong(sub2ind([T ns],subs(:,1),subs(:,2))));

    % calculate denominator
        denom =  accumarray(subs(:,1:2),utils,[T ns],@sum) + exp(-m); % T x ns
        % --> need within-market/hh range of u to be less than 1400 such that m can be
        % within -700 to +700
        
    % calculate probability
       if T>1 || ns==1, pijt = utils./denom(sub2ind([T ns],subs(:,1),subs(:,2))); 
        else, pijt = utils./denom(sub2ind([T ns],subs(:,1),subs(:,2)))'; end
		   
            % same size as u, sorted by hh/draw, market, then product

    % reshape for micro moments - nhh x T x maxJt
        if reshapeout==1
            try pijt = ndSparse.build([subs(:,2),subs(:,1),subs(:,3)],pijt,[ns T maxJt]);
            catch me
            disp('Hit error #2 inner...')
            subsmkt
            subsmkt_mat
            uniquehhmktsubs
            subs_mat
            subs_vec
            mktids.subs
            subs
            [ns T maxJt]
            numel(size(u))
            ndims(u)
            size(u)
            size(u,1)
            size(subs,1)
            size(pijt) % 9 x 9
            size(utils) % 9 x 1
            size(denom) % 1 x 1
            rethrow(me)     
            end							   
        end
    end
    