% this computes the relative share objective function and gradient
    function [Fdelta,dFddelta,dsddelta]=step3cii_Fdelta_par(pijt,pjt,ag,rellnsjt,w,ids,minT,maxT,nargs)
	
    % Inputs:  
        % pijt: [sumJt x ns] sorted by draw, market, then product
                % (implied purchase probabilities for simulated households)
        % rellnsjt, sumJt x 1 sorted by market then product
        % w: ns x 1
		
        mktsumJt=size(ids.subsmkt,1);
		mktmaxJt=max(ids.subsmkt(:,2));
		mktT=max(ids.subsmkt(:,1));
		
		subsvec = (ids.subsmkt(:,1)-1)*mktmaxJt+ids.subsmkt(:,2); 
			% to pull out non-missing products from each market, for data
			% sorted by market then product within market

    % extract and log predicted market shares
        sjt_deltamat = ndReshape(pjt',mktT*mktmaxJt,1);
             % T x maxJt x 1 --> maxJt x T x 1 --> T*maxJt (ordered by  market then by product within market)
        sjt_deltavec = full(sjt_deltamat(subsvec));
		lnsjt_delta = log(sjt_deltavec);
			% vector sorted by market then product (i.e., all products in mkt 1, all products in mkt 2, etc.)

        % if outside good data dropped, then calculate log predicted outside good share
            s0t_deltamat = reshape(repmat(1-sum(pjt,2),1,mktmaxJt)',mktT*mktmaxJt,1);
                % T x maxJt x 1 --> maxJt x T x 1 --> T*maxJt (ordered by  market then by product within market)
            s0t_deltavec = full(s0t_deltamat(subsvec));
            rellnsjt_delta = lnsjt_delta-log(s0t_deltavec);
   
    % difference predicted shares from observed shares
			try
				Fdelta=rellnsjt_delta-rellnsjt;
			catch fdeltaerror
					size_rellnsjt_delta=size(rellnsjt_delta)
					size_rellnsjt=size(rellnsjt)
					rethrow(fdeltaerror)
            end
                 %  (mkt)sumJt x 1

    if nargs>1        
   
        %dsddelta=diag(pijt*(w.*alphai.*gammai))-pijt*diag(w.*alphai.*gammai)*pijt';
            wag(:,1,:) = bsxfun(@times,w',ag); % mktT x 1 x ns;
            pijt_mat = ndSparse.build(ids.subs(:,[1 3 2]),pijt); % mktT x maxJt x  ns
                % sijt
               
            pijt_wag = bsxfun(@times,pijt_mat,wag); % mktT x maxJt x ns
                % alphai*gammai*wi*sijt

            arg1 = reshape(sum(pijt_wag,3)',[],1); % mktT*maxJt x 1 - ordered by market then product
                % sum(alphai*gammai*wi*sijt)

            j=repmat([1:mktmaxJt]',mktT,1);
            t=reshape(repmat([1:mktT],mktmaxJt,1),[],1);
            jjt = [j j t];
            N1 = ndSparse.build(jjt(subsvec,:),full(arg1(subsvec))); %  (mkt)sumJt x 1 --> maxJt x maxJt x T
            N2 = ndSparse.build([],[],[size(pijt_wag,2) size(pijt_wag,2) size(pijt_wag,1)],0);
            for i=1:size(wag,3) % for each simulated household
             %	   pijt_wag_sub=pijt_wag(:,:,i);	% maxJt x T x 1
                N2=N2+bsxfun(@times,permute(pijt_wag(:,:,i),[3 2 1]),permute(pijt_mat(:,:,i),[2 3 1]));
                    % [maxJt x 1 (ns) x T] times [1 (ns) x maxJt x T] -->
                    % [maxJt x maxJt x T] with each element pijt * pij't
            end
           
            % calculate and pull out dsddelta for existing deltas
                dsddeltatemp = sparse2d(permute(N1-N2,[1 3 2]));   		
                    % maxJt x maxJt x T --> maxJt x T x maxJt --> maxJt*T x maxJt
                dsddeltatemp = reshape(dsddeltatemp(subsvec,:),[],1); 	
                    % maxJt*T x maxJt -->  sumJt x maxJt -->  sumJt * maxJt x 1
                    % ordered by product then by delta (i.e., all deltas for one product, then all deltas for next product, etc.)
            
            % identify sparsity pattern and allocate to the appropriate markets
                B=ndSparse.build([ones(mktsumJt,1) ids.subsmkt(:, [2 1])], ones(mktsumJt,1)); % 1 x mktmaxJt x mktT
                sppattern = sparse2d(permute(bsxfun(@times,permute(B,[2 1 3]),B),[1 3 2])); 
                    % maxJt x maxJt x T --> maxJt x T x maxJt --> maxJt*T x maxJt
                sppattern = sppattern(subsvec,:); 	
                    % maxJt*T x maxJt -->  sumJt x maxJt
                t=[repmat(ids.subsmkt(:,1),mktmaxJt,1)];				% mkt subs for deltas	
                jt=[repmat([1:mktsumJt]',mktmaxJt,1)]; 					% delta subs
                j=reshape(repmat([1:mktmaxJt],mktsumJt,1),[],1);        % product subs                                              
                tjtj=[t jt j];
                % use sparsity pattern to work only with dsddeltatemp elements that are relevant for this
                % set of market-product pairs...
                spindexes=find(sppattern);
                dsddelta = ndSparse.build(tjtj(spindexes,:), full(dsddeltatemp(spindexes)));    
                    % mktT x mktsumJt x maxJ

        %dFddelta
             template_jt = [ids.subsmkt(:, 1) ones(mktsumJt,1) ids.subsmkt(:,2)];
             pjt_permute = permute(pjt,[2 1]);
                % maxJt x mktT
            pjt_long = ndReshape(pjt_permute,mktmaxJt*mktT,1);
                % sorted by market then product
            invpjt = ndSparse.build(template_jt,1./(pjt_long(subsvec)));

           try
                dlnsddelta = bsxfun(@times,dsddelta,invpjt);	% [T x mktsumJt x maxJt] 
           catch dlnsddeltaerror
                  size_dsddelta=size(dsddelta)
                  size_pjt=size(pjt)  
                  rethrow(dlnsddeltaerror)
           end
           dlns0ddelta = bsxfun(@rdivide,-sum(dsddelta,3),1-sum(pjt,2));	% [T x mktsumJt] 
            dFddelta = bsxfun(@minus,dlnsddelta,dlns0ddelta); % [T x mktsumJt x maxJt] 
            clearvars ddeltasddelta dlns0ddelta dlnsddelta dsddelta pjt
           try
                dFddelta = ndReshape(permute(dFddelta,[3 1 2]),mktmaxJt*mktT,mktsumJt);	
            catch dFddeltaerror
                size_dFddelta=size(dFddelta)
                mktsumJt
                mktmaxJt
                mktT
                rethrow(dFddeltaerror)
           end
                    % [maxJt*T x mktsumJt] ordered by market then by product
           mktsubsvec = (ids.subsmkt(:,1)-1)*max(ids.subsmkt(:,2))+ids.subsmkt(:,2);	%
           dFddelta = sparse(dFddelta(mktsubsvec,:));
                    % [mktsumJt x mktsumJt] 
            
    end
end
   