% this computes the relative share Hessian
  function [out]=step3d_d2Fddelta2_par(mktlambda,mktdelta,theta,mktdata,mktidssubs,mktidssubsmkt,...
				mktdrawslninc,mktdrawsw,esta1,estg,sumJt,ntheta,...
				ns,minT,maxT,mktstart,mktend);
	% calculation of con_s and dsddelta/dsdtheta...

	%**************************************************************************
	% Matches top of step4bi_cons_s_par.m which calculates con_s and Jacobian

    % extract parameters
	   alpha0 = theta(1);
	   gamma = 0; alpha1 = 0;
	   if esta1==1
		   alpha1 = theta(2); 
		   if estg==1, gamma = theta(3); end
	   else
		   if estg==1, gamma = theta(2); end 
       end

    %switch market identifier to be relative to minimum market included   
		mktsumJt = size(mktdata.mktid,1);
		minmkt=min(mktdata.mktid);
		mktdata.mktid=mktdata.mktid-minmkt+1;
		mktidssubs(:,1)=mktidssubs(:,1)-minmkt+1;
		mktidssubsmkt(:,1)=mktidssubsmkt(:,1)-minmkt+1;	
		mktT = max(mktdata.mktid);
	        
    %switch product identifier to be a 1:J count within each of these markets
        [~,~,mktdata.newprodid]=unique([mktdata.mktid mktdata.prodid], 'rows');
        minprodinmkt=accumarray(mktdata.mktid,mktdata.newprodid,[],@min);
        mktdata.newprodid=1+mktdata.newprodid-minprodinmkt(mktdata.mktid);
		mktmaxJt = max(mktdata.newprodid);
        mktprods=unique([mktdata.mktid mktdata.prodid mktdata.newprodid], 'rows');
		mktprods=ndSparse.build(mktprods(:,1:2),mktprods(:,3));
        mktidssubs(:,3)=mktprods(sub2ind(size(mktprods),mktidssubs(:,1),mktidssubs(:,3)));
		mktidssubsmkt(:,2)=mktdata.newprodid;
        mktdata.prodid=mktdata.newprodid; mktdata.newprodid=[];
		subsvec = (mktidssubsmkt(:,1)-1)*max(mktidssubsmkt(:,2))+mktidssubsmkt(:,2);
            %ordered by market then by product within market

    %set up draw-specific coefficients
        lninc=mktdrawslninc;                     % T x ns
        alphai= alpha0+alpha1*lninc;            % T x ns
        gammai= 1+gamma*lninc;                  % T x ns
  
    %compute purchase probabilities    
        ag=alphai.*gammai;                      % T x ns 		
        u=reshape(bsxfun(@times,mktdelta,ag(mktdata.mktid,:))...
					-bsxfun(@times,mktdata.relx,alphai(mktdata.mktid,:)),[],1);
             %  implied utility (up to idiosyncratic logit error), sorted by draw then market then product
			 
		mktids=struct('subs',mktidssubs,'subsmkt',mktidssubsmkt,'N',mktsumJt,'maxJt',mktmaxJt);
				%structure array with counts and concordances to pass;
		
        pijt = step3ci_rc_shares_multmkt(u,mktids); % compute purchase probabilities
            % sorted by draw, market, then product
		pijt_mat = ndSparse.build(mktidssubs(:,[1 3 2]),pijt,[mktT mktmaxJt ns],numel(pijt));
			% T x maxJt x ns
		pjt = sum(bsxfun(@times,pijt_mat,permute(mktdrawsw,[2 3 1])),3);
			% T x maxJt x 1

    %**************************************************************************
	% [dsddelta,d2sddelta2]: first and second derivative of simulated market share with respect to delta

		[dsddelta,d2sddelta2]=step3di_d2sddelta2_par(pijt,ag,mktdrawsw,mktids);   
			% dsddelta is [maxJt (j'') x 1 (j') x maxJt (j) x 1 x T]
			% d2sddelta2 is [maxJt (j'') x maxJt (j') x maxJt (j) x 1 x T]
        dsddelta = permute(dsddelta,[1 2 3 5 4]);
        d2sddelta2 = permute(d2sddelta2,[1 2 3 5 4]);
%
	%************************************************************************************************
	%************************************************************************************************
	% Build Hessian...
	
            pjt_permute = permute(pjt,[3 4 2 1]);
                % 1 x 1 x maxJt x mktT
            pjt_long = ndReshape(pjt_permute,mktmaxJt*mktT,1);
                % sorted by market then product
            template_jt = [ones(mktsumJt,2) mktidssubsmkt(:, [2 1])];
            invpjt2 = ndSparse.build(template_jt,1./(pjt_long(subsvec).^2));
            
        %************************************************************************************************		
		           
			% combine d2sdtheta2 with d2sddelta2 and d2sdthetaddelta...and
			% calculate sd2sdtheta2
				d2sdX2 = d2sddelta2;					 
					% [maxJt x maxJt x maxJt (j) x T] 
                    
                sd2sdX2 = bsxfun(@times,pjt_permute,d2sdX2);
                
             % combine dsdtheta with dsddelta & calculate dsdX * dsdX'...
                dsdX = dsddelta;
                    % dsddelta is [maxJt (j'') x 1 (j') x maxJt (j) x T]
               dsdXINTdsdX = bsxfun(@times,dsdX, permute(dsdX,[2 1 3 4]));
					% [maxJt x maxJt x maxJt (j) x T]

		   % difference and divide by s_jt^2
				d2FjdX2 = bsxfun(@times,sd2sdX2-dsdXINTdsdX,invpjt2);
					% maxJt x maxJt x maxJt x mktT
		
        %************************************************************************************************		
 		% d2FdX2...
			
            % calculate d2s0dX2 and divide by outside good share to calculate (1-sum_j s)*d2s0dX2
				p0t = 1-sum(pjt_permute,3); % 1 x 1 x 1 x mktT
				s0d2s0dX2 = bsxfun(@times,sum(d2sdX2,3),p0t);
					% maxJt x maxJt x 1 x mktT
		
           % calculate ds0dx * ds0dx'... and divide by outside good share squared
				ds0dX = sum(dsdX,3);
				ds0dXINTds0dX = bsxfun(@times, ds0dX, permute(ds0dX,[2 1 3 4]));
					% maxJt x maxJt x 1 x mktT	
            
			% sum and divide by s_jt^2...        
                d2F0dX2 = -bsxfun(@rdivide,s0d2s0dX2+ds0dXINTds0dX,p0t.^2);
					% maxJt x maxJt x 1 x mktT
                    
            %difference 2nd derivative at product level from outside good 2nd derivative...
                 d2FdX2 = bsxfun(@minus,d2FjdX2,d2F0dX2);
                   % maxJt x maxJt x maxJt x mktT  

		%************************************************************************************************
		% Mean Utility/Share Hessian: sum(lambda_j d2F_jdX2)...
				
				%multiply by lambda
                    lambdaalloc = ndSparse.build(template_jt,mktlambda);
						%  (mkt)sumJt x 1 --> 1 x 1 x maxJt x T

                %collapse across products in each market
					d2lambdasumFdX2 = sum(bsxfun(@times,d2FdX2,lambdaalloc),3);
                        % maxJt x maxJt x maxJt x mktT   --> maxJt x maxJt x 1 x mktT
					d2lambdasumFdX2 = permute(d2lambdasumFdX2,[1 2 4 3]);   		
						% maxJt x maxJt x 1 x mktT --> maxJt x maxJt x mktT
                    
		%************************************************************************************************
		% Pull out market-specific components and allocate to appropriate markets: 
		
				%extract d2Fddelta2 Hessian components for deltas that reflect tastes for products actually available in markets 
					d2Fddelta2 = d2lambdasumFdX2((1:mktmaxJt),(1:mktmaxJt),:);	
                        %maxJt x maxJt x mktT 
					d2Fddelta2 = ndReshape(permute(d2Fddelta2,[1 3 2]),[],mktmaxJt);  
						% maxJt x maxJt x mktT --> maxJt x mktT x maxJt --> maxJt*mktT x maxJt
                            % ordered by market then product within market
                
                    d2Fddelta2 = d2Fddelta2(subsvec,:); 	
						% maxJt*T x maxJt -->  sumJt x maxJt

				% allocate dFddelta2 to appropriate markets
					d2Fddelta2 = ndReshape(d2Fddelta2,[],1); 	% sumJt * maxJt x 1
						% ordered by product then by delta (i.e., all deltas for one product, then all deltas for next product, etc.)
					ts=[repmat(mktidssubsmkt(:,1),mktmaxJt,1)];				% mkt subs for deltas	
					jt=[repmat([1:mktsumJt]',mktmaxJt,1)]; 					% delta subs
					js=reshape(repmat([1:mktmaxJt],mktsumJt,1),[],1);		% product subs
					tjtj=[js ts jt];
                    
					d2Fddelta2 = ndSparse.build(tjtj(d2Fddelta2~=0,:), full(nonzeros(d2Fddelta2)),[mktmaxJt mktT mktsumJt]);    
						% maxJt x mktT x mktsumJt
                    d2Fddelta2 = ndReshape(d2Fddelta2,mktmaxJt*mktT,mktsumJt);	
                            % [maxJt*T x mktsumJt] ordered by market then by product
                    
                    out.d2Fddelta2=sparse(mktsumJt,sumJt); 
                    try
                        out.d2Fddelta2(:,min(mktstart):(min(mktstart)+size(d2Fddelta2,2)-1))=d2Fddelta2(subsvec,:);
                            % not min:max because d2Fddelta2 might not
                            % cover all jt's due to zeros.
                    catch d2Fddelta2error
                        save('step3d_d2Fddelta2_error.mat')
                        mktsumJt
                        sumJt
                       size(d2Fddelta2t)
                        size(d2Fddelta2)
                        out.d2Fddelta2(:,min(mktstart):(min(mktstart)+size(d2Fddelta2,2)-1))
                        max(subsvec)
                        max(mktidssubsmkt)
                        size(d2Fddelta2(subsvec,:))
                        rethrow(d2Fddelta2error)
                    end
					out.d2Fddelta2_sub = d2Fddelta2(subsvec,:);
 
end
% EOC

%************************************************************************************************
%************************************************************************************************
%************************************************************************************************
%************************************************************************************************
%************************************************************************************************
%************************************************************************************************

     