% this computes the relative share Hessian
    function [dsddelta,d2sddelta2]=step3di_d2sddelta2_par(pijt,ag,w,ids)
	
    % Inputs:  
        % pijt:  mktT x maxJt x ns
                % (implied purchase probabilities for simulated households)
        % rellnsjt, sumJt x 1 sorted by market then product
        % w: ns x 1
		
       mktidssubs=ids.subs;
       if size(pijt,2)==1
            maxsubs = max(mktidssubs,[],1);
            mktT = maxsubs(1);
            ns = maxsubs(2);
            maxJt = maxsubs(3);
            k=sortrows(mktidssubs(:,[1 3 2]),[3 1 2]);
            pijt_mat = ndSparse.build(k,pijt,[mktT maxJt ns]); 
            % mktT x maxJt x  ns
            % padding in case there are any markets without households (for micro moments)
       else,
            pijt_mat = pijt;
            [mktT, maxJt, ns] = size(pijt_mat);
       end
             
        mktsumJt=size(ids.subsmkt,1);
		mktmaxJt=max(ids.subsmkt(:,2));

		if size(w)==size(ag), 
                wag = permute(w.*ag, [1 3 2]); % mktT x 1 x ns;
                wag2 = w.*(ag.^2); % mktT x ns;
        else, 
                wag = permute(bsxfun(@times,w',ag), [1 3 2]); % mktT x 1 x ns;
                wag2 = bsxfun(@times,w',ag.^2); 	% mktT x ns
        end
        
		subsvec = (ids.subsmkt(:,1)-1)*maxJt+ids.subsmkt(:,2); 
			% to pull out non-missing products from each market, for data sorted by market then product

%************************************************************************************************
	%dsddelta
	
	% note: pijt_mat is mktT x maxJt x  ns;  pjt_mat is maxJt x T
	
	%first calculate dsddelta...

        pijt_wag = bsxfun(@times,pijt_mat,wag); % mktT x maxJt x ns
			% alphai*gammai*wi*sijt
		arg1 = sum(pijt_wag,3); % mktT x maxJt
			% sum(alphai*gammai*wi*sijt)
    
		[t j] = find(arg1);
        N1 = ndSparse.build([j j t],nonzeros(arg1),[maxJt maxJt mktT]); %  (mkt)sumJt x 1 --> maxJt x maxJt x T
        N2 = ndSparse.build([],[],[maxJt maxJt mktT],0);
        for i=1:size(wag,3) % for each simulated household
         %	   pijt_wag_sub=pijt_wag(:,:,i);	% maxJt x T x 1
			N2=N2+bsxfun(@times,permute(pijt_wag(:,:,i),[3 2 1]),permute(pijt_mat(:,:,i),[2 3 1]));
                % [maxJt x 1 (ns) x T] times [1 (ns) x maxJt x T] -->
                % [maxJt x maxJt x T] with each element pijt * pij't
        end
		dsddelta = permute(N1 - N2,[1 4 2 5 3]);
			% [maxJt (j'') x 1 x maxJt (j) x 1 x T]

%************************************************************************************************	
	%  ds2ddelta2

	% note: pijt_mat is mktT x maxJt x  ns;  pjt_mat is maxJt x T
	
		pijt_mat3 = permute(pijt_mat, [2 1 3]);  % maxJt x mktT x  ns
       [j t h] = ind2sub(size(pijt_mat3), find(pijt_mat3));
       
	% 3D diagonal component

        M1 = ndSparse.build([j j j t h],nonzeros(pijt_mat3),[maxJt maxJt maxJt mktT ns]); 
			% (mkt)sumJt x 1 --> maxJt x maxJt x maxJt x mktT x ns

	% 3-way cross component
        pijt_mat5 = permute(pijt_mat3, [4 5 1 2 3]);  % 1 x 1 x maxJt x mktT x  ns
        M2 = 2*bsxfun(@times, pijt_mat5,bsxfun(@times,permute(pijt_mat5,[3 1 2 4 5]),permute(pijt_mat5,[1 3 2 4 5]))); 
			% [maxJt x maxJt x 1 x mktT x  ns] x [1 x 1 x maxJt x mktT x  ns] --> [maxJt x maxJt x maxJt x mktT x ns]

    % cross components
		pijt_diag = permute(ndSparse.build([j j t h],nonzeros(pijt_mat3),[maxJt maxJt mktT ns]),[1 2 5 3 4]);
			% (mkt)sumJt x 1 --> maxJt x maxJt x 1 x mktT x ns --> maxJt x maxJt x 1 x mktT x ns
		M3 = bsxfun(@times,pijt_diag,pijt_mat5);
			% [maxJt x maxJt x 1 x mktT x  ns] x [1 x 1 x maxJt x mktT x  ns] --> [maxJt x maxJt x maxJt x mktT x ns]
		M3 = M3+bsxfun(@times,permute(pijt_diag,[1 3 2 4 5]),permute(pijt_mat5,[1 3 2 4 5]));
			% [maxJt x 1 x maxJt x mktT x  ns] x [1 x maxJt x 1 x mktT x  ns] --> [maxJt x maxJt x maxJt x mktT x ns]
		M3 = M3+bsxfun(@times,permute(pijt_diag,[3 1 2 4 5]),permute(pijt_mat5,[3 1 2 4 5]));
			% [1 x maxJt x maxJt x mktT x  ns] x [maxJt x 1 x 1 x mktT x  ns] --> [maxJt x maxJt x maxJt x mktT x ns]

	% combine and multiply by (w*ag).^2 and sum across ns
		d2sddelta2 = sum(bsxfun(@times,permute(wag2,[3 4 5 1 2]),M1+M2-M3), 5);
			% [maxJt x maxJt x maxJt x mktT x 1]			

    %added with micro moments:
        d2sddelta2 = permute(d2sddelta2, [1 2 3 5 4]);
            % [maxJt x maxJt x maxJt x mktT x 1] --> [maxJt x maxJt x maxJt x 1 x mktT]

end

   