function [f, grad_f, ddeltadtheta, dgdtheta, delta, xi, g, dg2dtheta, sharebeta_j, expdiff, ...
        dg3dtheta, g2_j, g3_h, dgddelta, dg2ddelta, dg3ddelta, g2_t, g3_t, N_m, N_t] = step4a_gmmobjective(theta)

    nargs = nargout; 
    if nargout>1, nargs=4; 
	else nargs=2; end
    

    global data hhdata ids draws ns esta1 estg micro scalingfactors wgtmat
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% set-up

for collapse=1:1,
 
    % extract dimensions
        sumJt=ids.sumJt; 
		maxJt=max(ids.subsmkt(:,2)); 
		T=max(ids.subsmkt(:,1));
        ntheta=1+esta1+estg;
        
    % extract parameters
       theta=scalingfactors.theta*theta;     
     
	% assign null values to outputs that might not be assigned due to irrelevance
       dg2dtheta=[]; dg2ddelta=[]; dg3dtheta=[]; dg3ddelta=[]; sharebeta_j=[]; expdiff=[]; g2_j=[]; g3_h=[]; g2_t=[]; g3_t=[]; N_m=[]; N_t=[];
       
end % end of collapse

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% delta (mean utility) values using fixed point algorithm

        [delta,deltaerror] = step3a_alldeltas(theta);
        beta_hat = data.pre'*delta; % sumJt x B
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%        
%% store-level moments and gradient   

for collapse=1:1,
    
        xi = delta - beta_hat(data.brandid);  
        g = data.relZ'*xi;
        
        if nargout>1, % gradient function

            % calculate jacobian in parallel   
                ddeltadtheta = sparse(zeros(1,ntheta));
				 for t=1:ids.nTset, 
					mint=ids.Tsetmin(t); maxt=ids.Tsetmax(t);
					mktdelta=delta(ids.mktstart(mint,:):ids.mktend(maxt,:));
					con_s_cell=step3c_cons_s_par(mktdelta,theta,...
							data((data.mktid>=mint & data.mktid<=maxt),:),...
							ids.subs((ids.subs(:,1)>=mint & ids.subs(:,1)<=maxt),:),...
							ids.subsmkt((ids.subsmkt(:,1)>=mint & ids.subsmkt(:,1)<=maxt),:),...
							draws.lninc(mint:maxt,:),draws.w,...
							nargs,esta1,estg,sumJt,ntheta,ns,mint,maxt,...
							ids.mktstart(mint:maxt,:),ids.mktend(mint:maxt,:));
					 jac_t = -(con_s_cell.dFdmktdelta\con_s_cell.dFdtheta);
					ddeltadtheta  = [ddeltadtheta; sparse(jac_t)];
				  end  

                ddeltadtheta  = ddeltadtheta(2:end,:);
                
            % compile for gradient function
               prejacobian = data.pre'*ddeltadtheta;
                dxidtheta = ddeltadtheta - prejacobian(data.brandid,:);
                dgdtheta = data.relZ'*dxidtheta;
                Zpre=sparse(data.relZ'*data.pre);   % K x B
                dgddelta = sparse(data.relZ'-Zpre(:,data.brandid)); 
                    % dGddelta (sumJt x nK)'*(sumJt x sumJt) --> nK x sumJt
                %dgdtheta = ddeltadtheta'*dGddelta';
				
                grad_f = 2*dgdtheta'*wgtmat(1:size(g,1),1:size(g,1))*g;    % ntheta x 1
       
        end

       
end % end of collapse
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% microBLP moments and gradient

for collapse=1:1,
    
    if micro>0,

   %calculate inputs in parallel  
        con_g2_cell=cell(1,ids.nTset);
		for t=1:ids.nTset, 
			mint=ids.Tsetmin(t); maxt=ids.Tsetmax(t);
			if size(hhdata.mktid(hhdata.mktid>=mint & hhdata.mktid<=maxt))>0,
				mktdelta=delta(ids.mktstart(mint,:):ids.mktend(maxt,:));
				con_g2_cell{t}=step4bi_cons_g2_par(mktdelta,theta,...
						hhdata((hhdata.mktid>=mint & hhdata.mktid<=maxt),:),...
						data.relx((data.mktid>=mint & data.mktid<=maxt),:),...
						ids.subsmkt((ids.subsmkt(:,1)>=mint & ids.subsmkt(:,1)<=maxt),:),...
						nargs,esta1,estg,sumJt,ntheta,ns,maxJt,T,mint,maxt,...
						ids.mktstart(mint:maxt,:),ids.mktend(mint:maxt,:));
				con_g2_cell{t}.hhrel=1;
			else,
				
				con_g2_cell{t}.st=sparse(zeros(maxt-mint+1,maxJt));
				con_g2_cell{t}.Yst=sparse(zeros(maxt-mint+1,maxJt));
				
				 if nargs>2, 
					con_g2_cell{t}.dsdtheta=[];
					con_g2_cell{t}.Ydsdtheta=[];
					con_g2_cell{t}.dsddelta=[];
					con_g2_cell{t}.Ydsddelta=[];
				 end
				
				con_g2_cell{t}.sP=[];
				con_g2_cell{t}.ppaid=[];
				con_g2_cell{t}.sppaid=[];

				if nargs>2, 
					con_g2_cell{t}.dsdthetaP=[];
					con_g2_cell{t}.dPsdtheta=[];
					con_g2_cell{t}.dsddeltaP=[];
					con_g2_cell{t}.dPsddelta=[];
				end
				
				con_g2_cell{t}.hhrel=0;
				
			end
		end
    
	% when nargs = 2 out includes: st, Yst, sP, ppaid, sppaid
	% when nargs > 2 out includes: st, Yst, dsdtheta, Ydsdtheta, dsddelta, Ydsddelta, sP, ppaid, sppaid, dsdthetaP, dPsdtheta, dsddeltaP, dPsddelta
        con_g2_outapp=cat(1,con_g2_cell{:});
        names=fieldnames(con_g2_outapp);
        for i=1:(numel(names)-1),
            first=1;
            for t=1:size(con_g2_outapp,1),
                eval(['temp2= con_g2_outapp(t).(names{i});']);
                if numel(temp2)>0 & first==1, temp=temp2; first=0; 
                elseif numel(temp2)>0 & first==0,
                    if i<3, temp=[temp;temp2]; end
                    if i>2 && i<7, 
                        if nargs>2, temp = temp + temp2; 
                        else temp=cat(2,temp,temp2); end
                    end
                    if i>6, temp=cat(2,temp,temp2); end
                end
            end
            if  (i<=6 & nargs>2) || (i<=2 & nargs==2), 
                temp = temp(:,ids.relhhprods); 
            end
            eval([names{i} '= temp;']);
        end
        
        Ys=sum(Yst,1);   
        s=sum(st,1);   
            % from T x maxJ --> 1 x maxJ - one observation per product
        
            % G2 components...
                % s,Ys: 1 x maxJ 
                % Ydsddelta,dsddelta: size(theta) x maxJ
                % Ydsdtheta,dsdtheta: sumJt x maxJ

                
            % G3 components... N = size(hhdata,1)
                % ppaid: 1 x N
                % sppaid: 1 x N 
                % sP: 1 x N
                % dsdthetaP, dPsdtheta: ntheta x N
                % dsddeltaP, dPsddelta: mktsumJt (ndelta) x N

     % quality moments               
        % beta/dbetadX inputs
            brandsbyprod = accumarray(data.prodid,data.brandid,[],@mean);
            beta_j = beta_hat(brandsbyprod);
            beta_jrel = beta_j(ids.relhhprods);
            pre_j = data.pre(:,brandsbyprod);
            pre_jrel = pre_j(:,ids.relhhprods);

        %calculate moments    
            N_j = (size(hhdata.w,1)/sum(hhdata.w))*accumarray(hhdata.selection, hhdata.w,[],[],0);
                % scale weights that sum to the number of households
            Zbar_j = accumarray(hhdata.selection, hhdata.lninc.*hhdata.w,[],[],0)./N_j;
                Zbar_j = Zbar_j(ids.relhhprods);
                N_j = N_j(ids.relhhprods);
            EZ_j = Ys./s;
            expdiff=(Zbar_j-EZ_j');
            share_j = (N_j/sum(N_j));
            sharebeta_j = share_j.*beta_jrel;
			g2_j = sharebeta_j.*expdiff;
            g2 = sum(g2_j);

            N_jt =  (size(hhdata.w,1)/sum(hhdata.w))*accumarray([hhdata.selection hhdata.mktid], hhdata.w,[],[],0);
                % scale weights that sum to the number of households
            Zbar_jt = accumarray([hhdata.selection hhdata.mktid], hhdata.lninc.*hhdata.w,[],[],0)./N_jt;
                Zbar_jt(N_jt==0)=0;
                Zbar_jt = Zbar_jt(ids.relhhprods,:);
                Zbar_jt = [Zbar_jt zeros(size(Zbar_jt,1),max(data.mktid)-max(hhdata.mktid))];
                N_jt = N_jt(ids.relhhprods,:);
                N_jt = [N_jt zeros(size(N_jt,1),max(data.mktid)-max(hhdata.mktid))];
            EZ_jt = Yst./st; EZ_jt(st==0)=0;
            expdiff_jt=(Zbar_jt-EZ_jt');
            invN_jt=1./sum(N_jt,1); invN_jt(sum(N_jt,1)==0)=0;
            share_jt = bsxfun(@times,N_jt,invN_jt);
            sharebeta_jt = bsxfun(@times,share_jt,beta_jrel);
           g2_t = sum(sharebeta_jt.*expdiff_jt,1)';

    % price moments
        %calculate moments
            N_m = sum(N_j); % scalar
            Zbar = (hhdata.lninc'*hhdata.w)/N_m;  % scalar
            Eppaid = sppaid./sP;     
            ppaid_diff = full((ppaid - Eppaid)'); % N x 1
            temp = sum(hhdata.w.*ppaid_diff)./N_m;      % scalar
			g3_h = hhdata.w.*(hhdata.lninc - Zbar).*(ppaid_diff-temp)./N_m;
            g3 = sum(g3_h);     % scalar
    
    % market-level micro moment components for upper-level standard
    % errorcalculation (Vfh)
        g3_t = [accumarray(hhdata.mktid,g3_h,[],[],0); zeros(max(data.mktid)-max(hhdata.mktid),1)];
        N_t = [(size(hhdata.w,1)/sum(hhdata.w))*accumarray(hhdata.mktid, hhdata.w,[],[],0); zeros(max(data.mktid)-max(hhdata.mktid),1)];
            % scale weights that sum to the number of households
                  
    % add micro moments to vector of macro moments
            g = [g; g2; g3];

    % calculate and add on to gradient
        if nargout>1,
     
        %dg2dtheta
            dEZdtheta = bsxfun(@rdivide,bsxfun(@times,s,Ydsdtheta) - bsxfun(@times,Ys,dsdtheta),(s.^2)); % ntheta x maxJrel
            dg2dtheta = bsxfun(@times,sharebeta_j',-dEZdtheta);  % ntheta x maxJrel
            dg2dtheta = sum(dg2dtheta,2);
                        % ntheta x 1
        
        %dg3dtheta
            dEpdtheta = bsxfun(@rdivide,bsxfun(@times,sP,dPsdtheta) - bsxfun(@times,sppaid,dsdthetaP),sP.^2);
                % ntheta x N
                % old demoninator (permute(sP+(sP==0),[3 1 2]).^2)) --> sP+(sP==0) is for cases in
                % which sP == 0, such that the numerator will also be equal
                % zero, so as not to get NaNs.
            dg3dtheta = bsxfun(@minus,dEpdtheta,(dEpdtheta*hhdata.w)/N_m);
                % ntheta x N
            dg3dtheta = -(bsxfun(@times,(hhdata.lninc - Zbar),dg3dtheta')'*hhdata.w)/N_m;  
                % ntheta x N * N x 1  --> ntheta x 1 
                
       % add to gradient function
           grad_f = grad_f + dg2dtheta*wgtmat(end-1) + dg3dtheta*wgtmat(end-1);
    %
        %dg2ddelta
            dEZddelta = bsxfun(@rdivide,bsxfun(@times,s,Ydsddelta) - bsxfun(@times,Ys,dsddelta),(s.^2));  
            dg2ddelta = bsxfun(@times,share_j',pre_jrel*(diag(full(expdiff)))) - bsxfun(@times,sharebeta_j',dEZddelta);  % sumJt x maxJrel
            dg2ddelta = sum(dg2ddelta,2);
				% sumJt (ndelta) x 1
                
        %dg3ddelta
            dEpddelta = bsxfun(@rdivide,bsxfun(@times,sP,dPsddelta) - bsxfun(@times,sppaid,dsddeltaP),sP.^2);
            ssub = [1:size(sP,2)];
            dEpddelta = (dPsddelta*sparse(ssub,ssub,full(sP)) - dsddeltaP*sparse(ssub,ssub,full(sppaid)))*sparse(ssub,ssub,full(sP.^(-2)));
                % ndelta x N
            % dg3ddelta = - [ dg3ddeltaA - dg3ddeltaB ] where:
                dg3ddelta = (dEpddelta*sparse(ssub,ssub,(hhdata.lninc-Zbar))*hhdata.w/N_m);
                    %  dg3deltaA: [ndelta x N * N x N --> ndelta x N * N x 1 --> ndelta x 1  
                dg3ddelta = (dEpddelta*hhdata.w/N_m)*((hhdata.lninc - Zbar)'*hhdata.w/N_m) - dg3ddelta;
                    %  dg3ddeltaB: [ndelta x N * N x 1 --> ndelta x 1] * [1 x N * N x  1 --> 1 x 1] --> ndelta x 1 ]
   
     %}         
        end % end of nargout>1

    end % end of micro==1       
 end % end of collapse
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
		f = full(g'*wgtmat*g);
 
            if deltaerror==1, f=1000000; end
                
        if nargout>1, grad_f=full(grad_f*scalingfactors.theta); end

end % EOC
