function [out]=step4bi_cons_g2_par(mktdelta,theta,hhdata,mktrelx,...
         mktidssubsmkt,nargs,esta1,estg,sumJt,ntheta,...
			ns,maxJt,T,minT,maxT,mktstart,mktend);
	% calculation of con_g and components necessary for micro moment constraint Jacobian

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Data setup

for collapse=1:1,
    
    % extract parameters
	   alpha0 = theta(1);
	   gamma = 0; alpha1 = 0;
	   if esta1==1
		   alpha1 = theta(2); 
		   if estg==1, gamma = theta(3); end
	   else
		   if estg==1, gamma = theta(2); end 
       end
     

	%switch market identifier to be relative to minimum market in the set 
		hhdata.mktid=hhdata.mktid-minT+1;
		mktidssubsmkt(:,1)=mktidssubsmkt(:,1)-minT+1;	
		mktT = maxT - minT + 1;         % T
    %switch product identifier to be a 1:J count within this set of markets
        [prodsubs,~,mktidssubsmkt(:,2)]=unique(mktidssubsmkt(:,2));
		mktmaxJt = size(prodsubs,1);
        mktprods=sparse(full(prodsubs), ones(mktmaxJt,1),[1:mktmaxJt]');
        hhdata.selection=mktprods(hhdata.selection);
        tsfmktprods=sparse([1:mktmaxJt]', full(prodsubs), ones(mktmaxJt,1),mktmaxJt,maxJt);
            % to be used to reassign r to "all market" product dimension
      
	%make household identifier 1:nhh 
		% worth switching household identifier to be relative to minimum household identifier in the set ??
		hhdata.mainhhid = hhdata.hhid;
        [~,~,hhdata.hhid]=unique([hhdata.mainhhid],'rows');
        sumHHt = size(hhdata.mktid,1);  
		maxHHt = max(hhdata.hhid);         % nhh
        hhidssubs = [hhdata.mktid hhdata.hhid hhdata.selection];
         
    % household-specific useful transforms
        lninc=ndSparse.build([hhdata.mktid hhdata.hhid],hhdata.lninc,[mktT maxHHt]);    % T x nhh
        w=ndSparse.build([hhdata.mktid hhdata.hhid],hhdata.w,[mktT maxHHt]);            % T x nhh
        wlninc = lninc.*w;      
        alphai = spones(lninc).*(alpha0+alpha1*lninc);           
        gammai = spones(lninc).*(1+gamma*lninc);   
        ag=alphai.*gammai;   
        assert(full(sum(sum(spones(lninc)-spones(alphai))))==0)
        
end % end collapse

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Constraints
 
for collapse=1:1,
    
    %compute purchase probabilities
        deltamat = ndSparse.build([mktidssubsmkt(:,2) ones(size(mktdelta)) mktidssubsmkt(:,1)],full(mktdelta),[mktmaxJt 1 mktT]);
        relxmat =  ndSparse.build([mktidssubsmkt(:,2) ones(size(mktdelta)) mktidssubsmkt(:,1)],mktrelx,[mktmaxJt 1 mktT]);
            %  mktmaxJt x nhh (1) x  T
    
    % rework so that u is a vector - lower memory requirements?
        % u is sorted by draw then by market then by product, i.e., all obs for draw1 come before all obs for draw2, etc.
        % within each draw, all obs for market 1 come before all obs for market 2, etc.
    
        u=permute(bsxfun(@times,deltamat,permute(ag,[3 2 1]))...
    				-bsxfun(@times,relxmat,permute(alphai,[3 2 1])),[2 3 1]);
                % mktmaxJt x 1 x T **  1 x nhh x T --> mktmaxJt x nhh x T --> nhh x T x mktmaxJt
             %  implied utility (up to idiosyncratic logit error)

        mktids=struct('subs',hhidssubs,'subsmkt',mktidssubsmkt,'N',sumHHt,'maxJt',mktmaxJt);
				%structure array with counts and concordances to pass;
        try pijt = step3ci_rc_shares_multmkt(u,mktids); % compute purchase probabilities
           %  nhh x T x mktmaxJt
        catch me
            disp('Hit error...')
            size(u)         % 21 x 70 x 7
            size(deltamat) % 7 x 1 x 70
            size(ag)        % 70 x 21
            size(relxmat)   % 7 x 1 x 70
            [maxHHt mktT mktmaxJt]  % 21 x 70 x 7
            rethrow(me)
        end    		

        pijt_mat = permute(pijt,[2 3 1]);
			% T x mktmaxJt x nhh
    
        if size(pijt_mat,1)<mktT,
           size(pijt_mat)
            mktT
            pijt_mat = cat(1, pijt, zeros(mktT-size(pijt_mat),size(pijt_mat,2), size(pijt_mat,3)));
        end

    % inputs to compute expected income of households observed purchasing
    % each product in each market (check that weights sum to 1
    % wihtin a mkt) - for micro quality moments
        try out.st=sum(bsxfun(@times,pijt_mat,permute(w,[1 3 2])),3);
                % w to T x 1 x nhh to match pijt_mat, multiply then sum
                % across households and then markets --> T x mktmaxJt
           catch error
               mktT
               maxHHt
               mktmaxJt
               size(pijt_mat)
               size(permute(w,[1 3 2]))
               size(pijt)
               size(permute_pijt)
               size(pijt)
               save('step4bi_error.mat')
               rethrow(error)
        end
        
        out.Yst=sum(bsxfun(@times,pijt_mat,permute(wlninc,[1 3 2])),3);    
            % T x mktmaxJt - one observation per mkt * product
            % add rows for markets without households....
            
       if sum(isnan(out.Yst)+isnan(out.st))>0,
            out.Yst
            out.st
            save('testdatacons.mat')
            assert 1==2
       end
    
    % compute expected price paid by each household purchasing products
    % (for micro price moments)
        sP = sum(pijt,3) ; % nhh x T x mktmaxJt --> nhh x T
        ppaid = relxmat(sub2ind([mktmaxJt T],hhdata.selection,hhdata.mktid)); % mktmaxJt x 1 x T --> N x 1
        sppaid = sum(bsxfun(@times,permute(relxmat,[2 3 1]),pijt),3);
            % mktmaxJt x 1 x T --> nhh x T x mktmaxJt --> nhh x T
               
       
end % end collapse

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Jacobian inputs

for collapse=1:1,

    if nargs>2,	
       
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% components of dEZdtheta ([T x ntheta x mktmaxJt]) and dEpdtheta ([ntheta x T x nhh])
    % dsdtheta: derivative of simulated market share with respect to theta

        %    dfdtheta to be T x nhh x mktmaxJt x ntheta
            z=1;
            dfdtheta=permute(bsxfun(@minus,bsxfun(@times,deltamat,permute(gammai,[3 2 1])),...
                relxmat),[3 2 1 4]);
            if esta1==1, z=z+1; dfdtheta=cat(4, dfdtheta,bsxfun(@times,dfdtheta(:,:,:,1),lninc)); end;
            if estg==1, z=z+1; dfdtheta=cat(4, dfdtheta,permute(bsxfun(@times,deltamat,permute(alphai.*lninc,[3 2 1])),[3 2 1 4])); end;

            permute_pijt = permute(pijt,[2 1 3 4]);                     %  T x nhh x mktmaxJt x 1
           try x1 = bsxfun(@times, dfdtheta, permute_pijt);                %  T x nhh  x mktmaxJt x ntheta
           catch error
               mktT
               maxHHt
               mktmaxJt
               size(dfdtheta)
               size(permute_pijt)
               size(pijt)
               save('step4bi_error.mat')
               rethrow(error)
           end
            x2 = sum(x1, 3);                                            %  T x nhh  x 1 x ntheta
            x3 = bsxfun(@minus, dfdtheta, x2);                          %  T x nhh  x mktmaxJt x ntheta

            dsidtheta = bsxfun(@times,permute_pijt,x3);                 %  T x nhh  x mktmaxJt x ntheta
            dsdtheta = sparse2d(sum(sum(bsxfun(@times,bsxfun(@times,permute_pijt,x3),permute(w,[1 2 3])),2),1));  
   
        % components of dEZdtheta			   
            Ydsdtheta = sparse2d(sum(sum(bsxfun(@times,bsxfun(@times,permute_pijt,x3),permute(wlninc,[1 2 3])),2),1));     
                                            %  T x nhh x mktmaxJt x ntheta 
                                            %   --> T x 1 x mktmaxJt  x ntheta 
                                            % -->  mktmaxJt  x ntheta 
			out.dsdtheta = reshape(dsdtheta,mktmaxJt,ntheta)';                   % ntheta x mktmaxJt
            out.Ydsdtheta = reshape(Ydsdtheta,mktmaxJt,ntheta)';              	%  ntheta x mktmaxJt
            clearvars dsdtheta_vec Ydsdtheta_vec

          
            if sum(sum(isnan(dsdtheta)))
                disp('*******************************************')
                disp('...dsdtheta contains nan values.')
                dsdtheta
                save('errordata.mat')
                size(dsdtheta)
				dsdtheta(1:max(size(dsdtheta,1),20),:)
                return
            end
            
    % components of dEpdtheta    (both ntheta x nhh x T)    
            dsdthetaP = permute(sum(dsidtheta,3),[4 2 1 3]);  % summing over products j
            dPsdtheta = permute(sum(bsxfun(@times,permute(relxmat,[3 2 1 4]),dsidtheta),3),[4 2 1 3]); 
                % mktmaxJt x 1 x T --> T x nhh  x mktmaxJt x ntheta
                % --> T x nhh  x 1 x ntheta --> ntheta x nhh x T
                
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
% components of dEZddelta and dEpddelta
    %dsddelta=diag(pijt*(w.*alphai.*gammai))-pijt*diag(w.*alphai.*gammai)*pijt';
     
    % components of dEZddelta 
        % run first weighting and summing across households
        % then weight and pre-multiply by income and sum across households
    doneforboth=0;
    while doneforboth<2,  
            if doneforboth==0, wag = permute(w.*ag,[1 3 2]); % mktT x 1 x nhh;
            else, wag = permute(wlninc.*ag,[1 3 2]); % mktT x 1 x nhh;
            end
            pijt_wag = bsxfun(@times,pijt_mat,wag); % mktT x mktmaxJt x nhh
                % alphai*gammai*wi*sijt
            
        %diagonal component
            arg1 = reshape(sum(pijt_wag,3)',[],1); % mktT*mktmaxJt x 1 - ordered by market then product
               % mktT x mktmaxJt x nhh --> mktT x mktmaxJt x 1 --> mktmaxJt x mktT --> mktmaxJt*mktT  x 1			   
                % sum(alphai*gammai*wi*sijt)
            j=repmat([1:mktmaxJt]',mktT,1);
            t=reshape(repmat([1:mktT],mktmaxJt,1),[],1);
            jjt = [j j t];

            subsvec = (mktidssubsmkt(:,1)-1)*mktmaxJt+mktidssubsmkt(:,2); 
                % to pull out non-missing products from each market, for data
                % sorted by market then product within market        
            N1 = ndSparse.build(jjt(subsvec,:),full(arg1(subsvec)),[mktmaxJt mktmaxJt mktT]); %  (mkt)sumJt x 1 --> mktmaxJt x mktmaxJt x T
    
        %cross-interaction component
            N2 = ndSparse.build([],[],[mktmaxJt mktmaxJt mktT],0);
            for i=1:size(wag,3) % for each simulated household
             %	   pijt_wag_sub=pijt_wag(:,:,i);	% mktmaxJt x T x 1
                N2=N2+bsxfun(@times,permute(pijt_wag(:,:,i),[3 2 1]),permute(pijt_mat(:,:,i),[2 3 1]));
                    % [mktmaxJt x 1 (ns) x T] times [1 (ns) x mktmaxJt x T] -->
                    % [mktmaxJt x mktmaxJt x T] with each element pijt * pij't
            end

        %merge components and pull out dsddelta for existing deltas
            dsddeltatemp = sparse2d(permute(N1-N2,[1 3 2]));   		
                % mktmaxJt x mktmaxJt x T --> mktmaxJt x T x mktmaxJt --> mktmaxJt*T x mktmaxJt
            dsddeltatemp = dsddeltatemp(subsvec,:); 	
                % mktmaxJt*T x mktmaxJt -->  mktsumJt x mktmaxJt
                % delta x product
        % doesn't need to be allocated across markets, since
        % observations will be summed across markets...

            if doneforboth==0, 
                out.dsddelta = sparse(sumJt,mktmaxJt); 
                out.dsddelta(min(mktstart):max(mktend),:) = dsddeltatemp; %  sumJt x mktmaxJt
            else, 
                out.Ydsddelta = sparse(sumJt,mktmaxJt);  
                out.Ydsddelta(min(mktstart):max(mktend),:) = dsddeltatemp; %  sumJt x mktmaxJt
            end 
            doneforboth=doneforboth+1;

    end
    
    % components of dEpddelta 
        % not summing across either products or households (or markets)
        % until after dsddelta and dsPddelta are calculated, when summed across products.
   
        ag = permute(ag,[1 3 2]); % mktT x 1 x nhh;
        pijt_ag = bsxfun(@times,pijt_mat,ag); % mktT x mktmaxJt x nhh
                % alphai*gammai*wi*sijt
              
        %diagonal component
            arg1 = ndReshape(permute(pijt_ag,[2 1 3]),[],size(pijt_ag,3)); % alphai*gammai*wi*sijt
                % mktT x mktmaxJt x nhh --> mktmaxJt x mktT x nhh --> mktT*mktmaxJt x nhh  - ordered by market then product
                    % ndReshape since sparse2d won't work when nhh = 1
            j=repmat([1:mktmaxJt]',mktT,1);
            t=reshape(repmat([1:mktT],mktmaxJt,1),[],1);
            jjt = [j j t];
            subsvec = (mktidssubsmkt(:,1)-1)*mktmaxJt+mktidssubsmkt(:,2); 
                % to pull out non-missing products from each market, for data
                % sorted by market then product within market   
            jjth = [repmat(jjt(subsvec,:),maxHHt,1) reshape(repmat([1:maxHHt],size(subsvec,1),1),[],1)];
            findarg1 = find(arg1(subsvec,:));
            N1 = ndSparse.build(jjth(findarg1,:),nonzeros(arg1(subsvec,:)),[mktmaxJt mktmaxJt mktT maxHHt]); 
                % (mkt)sumJt x nhh --> mktmaxJt x mktmaxJt x T x nhh
  
        %cross-interaction component
            N2 = ndSparse.build([],[],[mktmaxJt mktmaxJt mktT maxHHt],0);
            N2 = bsxfun(@times,permute(pijt_ag,[4 2 1 3]),permute(pijt_mat,[2 4 1 3]));
                    % [mktmaxJt x 1 x T x nhh] times [1 x mktmaxJt x T x nhh] -->
                    % [mktmaxJt x mktmaxJt x T x nhh] with each element pijt_wag * pij't
            
        %merge components, sum across products and pull out dsddelta for existing deltas 
            ppaid2d = permute(relxmat,[1 3 2]); % mktmaxJt x 1 x T --> mktmaxJt x T
            reshapeNdiff = sparse2d(permute(N1-N2,[1 3 4 2])); 
                % mktmaxJt x mktmaxJt x T x nhh 
                % --> mktmaxJt x T x nhh x mktmaxJt 
                % --> mktmaxJt * T * nhh x mktmaxJt (since * only works for
                % 2D matrices)
          
        %multiply by prices (or 1/0 vector to indicate non-missing prices) and sum across products
            dsddeltaP = ndSparse(reshapeNdiff*sparse(ne(ppaid2d,0)),[mktmaxJt*mktT,maxHHt,mktT]);   		
                % mmktmaxJt * T * nhh x mktmaxJt * mktmaxJt x T --> 
                % --> mktmaxJt * T * nhh x T --> mktmaxJt*T x nhh x T
            dsddeltaP = dsddeltaP(subsvec,:,:); 	
                % mktmaxJt*T x nhh x T -->  mktsumJt (ndelta) x nhh x T 
        
            dPsddelta = ndSparse(reshapeNdiff*ppaid2d,[mktmaxJt*mktT,maxHHt,mktT]);   		
                % mktmaxJt x mktmaxJt x T x nhh --> mktmaxJt x T x nhh x mktmaxJt
                % --> mktmaxJt x T x nhh x mktmaxJt * mktmaxJt x T --> 
                % --> mktmaxJt x T x nhh x T --> mktmaxJt*T x nhh x T
            dPsddelta = dPsddelta(subsvec,:,:); 	
                % mktmaxJt*T x nhh x T -->  mktsumJt (ndelta) x nhh x T 

	end
end % end collapse

    % reassign current out. results (st, Yst, dsdtheta, Ydsdtheta, dsddelta, and Ydsddelta) to full K x maxJt arrays (K x mktmaxJt --> K x maxJt)
		names=fieldnames(out);
        for i=1:numel(names),
           eval(['temp = out.(names{i}) * tsfmktprods;']);
           out.(names{i}) = temp;
        end
      
    % for components of the shape nhh x T --> 1 x N
        j = sub2ind([maxHHt mktT],hhdata.hhid,hhdata.mktid);
        out.sP = sP(j)'; 
        out.ppaid = ppaid'; 
        out.sppaid = sppaid(j)';
        
  if nargs>2,	
      % for components of the shape K x nhh x T --> K x N
        out.dsdthetaP = dsdthetaP;
        out.dPsdtheta = dPsdtheta; 
        temppre = ndSparse.build([],[],[min(mktstart)-1,size(dsddeltaP,2),size(dsddeltaP,3)],0); 
        temppost = ndSparse.build([],[],[sumJt-max(mktend),size(dsddeltaP,2),size(dsddeltaP,3)],0); 
        out.dsddeltaP = cat(1,temppre,dsddeltaP,temppost); %  sumJt x nhh x mktmaxJt  
        out.dPsddelta = cat(1,temppre,dPsddelta,temppost); %  sumJt x nhh x mktmaxJt
        names={'dsdthetaP','dPsdtheta','dsddeltaP','dPsddelta'};
        for i=1:numel(names),
           eval(['temp = out.(names{i});']);
           temp = ndReshape(temp,size(temp,1),[]); % K x nhh x T -->  K x nhh*T 
           out.(names{i}) = temp(:,j);  % K x n
        end        
  end
end % EOC

%************************************************************************************************
%************************************************************************************************
%************************************************************************************************


      function [out] = solvevijt(x,esta1,estg,hhdata,mktrelx,hhidssubs,mktidssubsmkt,sumHHt,maxJt,T,maxHHt,minT,maxT);
		
        vijt = vijtmat(x,esta1,estg,hhdata,mktrelx,hhidssubs,mktidssubsmkt,sumHHt,maxJt,T,maxHHt,minT,maxT);
        out = ndReshape(permute(vijt,[3 2 1]),[],1);
            % nhh x T x mktmaxJt --> mktmaxJt x T x nhh -->  sorted by draw, market, then product     
           
      end
      
      
      function [out] = vijtmat(x,esta1,estg,hhdata,mktrelx,hhidssubs,mktidssubsmkt,sumHHt,maxJt,T,maxHHt,minT,maxT);
		
    % extract parameters
           theta = x(1:1+esta1+estg);
           mktdelta = x((1+esta1+estg+1):end);
           alpha0 = theta(1);
           gamma = 0; alpha1 = 0;
           if esta1==1
               alpha1 = theta(2); 
               if estg==1, gamma = theta(3); end
           else
               if estg==1, gamma = theta(2); end 
           end
     
	%switch market identifier to be relative to minimum market in the set 
		hhdata.mktid=hhdata.mktid-minT+1;
		mktidssubsmkt(:,1)=mktidssubsmkt(:,1)-minT+1;	
		mktT = maxT - minT + 1;         % T
        
	%switch product identifier to be a 1:J count within this set of markets
       mktsumJt = size(mktidssubsmkt,1);											  
        [prodsubs,~,mktidssubsmkt(:,2)]=unique(mktidssubsmkt(:,2));
		mktmaxJt = size(prodsubs,1);
		mktprods=sparse(full(prodsubs), ones(mktmaxJt,1),[1:mktmaxJt]');
        hhdata.selection=mktprods(hhdata.selection);
        tsfmktprods=sparse([1:mktmaxJt]', full(prodsubs), ones(mktmaxJt,1),mktmaxJt,maxJt);
            % to be used to reassign r to "all market" product dimension       
	%make household identifier 1:nhh wiswitch household identifier to be relative to minimum household identifier in the set 
		hhdata.mainhhid = hhdata.hhid;
        [~,~,hhdata.hhid]=unique([hhdata.mainhhid],'rows');
        maxHHt = max(hhdata.hhid);         % nhh
       
    % hhdata.mktid: market identifiers (not 1 through T) matches those from store data;
    % hhdata.hhid: household transaction subscripts (1...nhh) in each market
    % hhdata.selection: product selected - 1 through J, including outside good (accords with data.prodid)
     % hhdata.lninc: household income
    % hhdata.units: number of units purchased by a household)
    % hhdata.w: hhdata.units/sum(hhdata.units)
               
    % household-specific useful transforms
        lninc=ndSparse.build([hhdata.mktid hhdata.hhid],hhdata.lninc,[mktT maxHHt]);    % T x nhh
        w=ndSparse.build([hhdata.mktid hhdata.hhid],hhdata.w,[mktT maxHHt]);            % T x nhh
            %lninc=lninc(sparsemktids,:);    % limit to markets where we actually see households
            %w=w(sparsemktids,:);            % limit to markets where we actually see households
        alphai= alpha0+alpha1*lninc;           
        gammai= 1+gamma*lninc;                 
        ag=alphai.*gammai;                      

        deltamat = ndSparse.build([mktidssubsmkt(:,2) ones(size(mktdelta)) mktidssubsmkt(:,1)],full(mktdelta),[mktmaxJt 1 mktT]);
        relxmat =  ndSparse.build([mktidssubsmkt(:,2) ones(size(mktdelta)) mktidssubsmkt(:,1)],mktrelx,[mktmaxJt 1 mktT]);
            %  mktmaxJt x nhh (1) x  T
        out=permute(bsxfun(@times,deltamat,permute(ag,[3 2 1]))...
					-bsxfun(@times,relxmat,permute(alphai,[3 2 1])),[2 3 1]);
                % mktmaxJt x 1 x T **  1 x nhh x T --> mktmaxJt x nhh x T --> nhh x T x mktmaxJt
                %  implied utility (up to idiosyncratic logit error)
            
      end

       
%************************************************************************************************  
% Vector-valued Functions for numeric Jacobian calculation
%************************************************************************************************       

       function [out] = jacfunPi(x,esta1,estg,hhdata,mktrelx,hhidssubs,mktidssubsmkt,sumHHt,maxJt,T,maxHHt,minT,maxT);
		
        %compute purchase probabilities
            u=vijtmat(x,esta1,estg,hhdata,mktrelx,hhidssubs,mktidssubsmkt,sumHHt,maxJt,T,maxHHt,minT,maxT);
              %  implied utility (up to idiosyncratic logit error), sorted by draw then market then product
                % nhh x T x mktmaxJt 
                
            mktids=struct('subs',hhidssubs,'subsmkt',mktidssubsmkt,'N',sumHHt);
                    %structure array with counts and concordances to pass;
            p_ijt = step3ci_rc_shares_multmkt(u,mktids); % compute purchase probabilities
               %  nhh x T x mktmaxJt  - sorted by draw, market, then product                
            out = ndReshape(permute(p_ijt,[3 2 1]),[],1);
            % nhh x T x mktmaxJt --> mktmaxJt x T x nhh -->  sorted by draw, market, then product     
        
       end
      function [out] = jacfunsumPi(x,esta1,estg,hhdata,mktrelx,hhidssubs,mktidssubsmkt,sumHHt,maxJt,T,maxHHt,minT,maxT);
		
        %compute purchase probabilities
            u=vijtmat(x,esta1,estg,hhdata,mktrelx,hhidssubs,mktidssubsmkt,sumHHt,maxJt,T,maxHHt,minT,maxT);
              %  implied utility (up to idiosyncratic logit error), sorted by draw then market then product
                % nhh x T x mktmaxJt 
                
            mktids=struct('subs',hhidssubs,'subsmkt',mktidssubsmkt,'N',sumHHt);
                    %structure array with counts and concordances to pass;
            p_ijt = step4ci_rc_shares_multmkt(u,mktids); % compute purchase probabilities
               %  nhh x T x mktmaxJt  
           
            out = ndReshape(sum(p_ijt,3),[],1);
            % nhh x T x mktmaxJt --> nhh * T  -->  sorted by market then draw
        
       end

       
      function [out] = jacfunsumPiP(x,esta1,estg,hhdata,mktrelx,hhidssubs,mktidssubsmkt,sumHHt,maxJt,T,maxHHt,minT,maxT);
		
        %compute purchase probabilities
            u=vijtmat(x,esta1,estg,hhdata,mktrelx,hhidssubs,mktidssubsmkt,sumHHt,maxJt,T,maxHHt,minT,maxT);
              %  implied utility (up to idiosyncratic logit error), sorted by draw then market then product
                % nhh x T x mktmaxJt 
                
            mktids=struct('subs',hhidssubs,'subsmkt',mktidssubsmkt,'N',sumHHt);
                    %structure array with counts and concordances to pass;
            p_ijt = step4ci_rc_shares_multmkt(u,mktids); % compute purchase probabilities
               %  nhh x T x mktmaxJt  
          
            relxmat =  ndSparse.build([mktidssubsmkt(:,2) ones(size(mktrelx)) mktidssubsmkt(:,1)],mktrelx,[size(p_ijt,3) 1 maxT-minT+1]);
            %  mktmaxJt x 1 x  T
            ppaidp_ijt = bsxfun(@times,permute(relxmat,[2 3 1]),p_ijt); % mktmaxJt x 1 x T --> nhh x T x mktmaxJt
                
            out = ndReshape(sum(ppaidp_ijt,3),[],1);
                % nhh x T x mktmaxJt --> nhh * T  -->  sorted by market then draw
        
       end

