#!/bin/bash
#$ -N step3_1_saveest
#$ -P real_handbury_team
#$ -l m_mem_free=5G
#$ -t 1-859:1
#$ -q short.q
#$ -j y

	pmodule=$( head -n$SGE_TASK_ID /home/real/handbury/NHP_Revision/0_dataimport/Code/productmodule_list_noncount.txt | tail -n1 )

	source="matlab"
    year=2012
    freq="month"
	spec="_nl"
	micro="2"
    outsidegoodscutoff="60"
    estdir="1"
  
#-------------------------------------------------
# Base Case
	estdir="1"
	stata-se do 1_estimatessave.do $source $pmodule $year $freq $spec $micro $outsidegoodscutoff $estdir > 2_estimatessave_${JOB_ID}_${SGE_TASK_ID}.log 2>&1

#-------------------------------------------------
# Robustness specifications:

# OG40
	estdir="2"
	outsidegoodscutoff="40"
    stata-se do 1_estimatessave.do $source $pmodule $year $freq $spec $micro $outsidegoodscutoff $estdir > 2_estimatessave_${JOB_ID}_${SGE_TASK_ID}.log 2>&1
	outsidegoodscutoff="60"
    
# OG80
	estdir="3"
	outsidegoodscutoff="80"
    stata-se do 1_estimatessave.do $source $pmodule $year $freq $spec $micro $outsidegoodscutoff $estdir > 2_estimatessave_${JOB_ID}_${SGE_TASK_ID}.log 2>&1
	outsidegoodscutoff="60"
    
# Quarterly data
	estdir="4"
	freq="quarter"
	stata-se do 1_estimatessave.do $source $pmodule $year $freq $spec $micro $outsidegoodscutoff $estdir > 2_estimatessave_${JOB_ID}_${SGE_TASK_ID}.log 2>&1
	freq="month"
	
# Drop markets with less than 1% outside good share (instead of less than 3%)
	estdir="5"
	stata-se do 1_estimatessave.do $source $pmodule $year $freq $spec $micro $outsidegoodscutoff $estdir > 2_estimatessave_${JOB_ID}_${SGE_TASK_ID}.log 2>&1

# Residualized instrument 
	estdir="6"
	stata-se do 1_estimatessave.do $source $pmodule $year $freq $spec $micro $outsidegoodscutoff $estdir > 2_estimatessave_${JOB_ID}_${SGE_TASK_ID}.log 2>&1

#-------------------------------------------------
# Additional specs for instrument checks

# OLS
	estdir="7"
	stata-se do 1_estimatessave.do $source $pmodule $year $freq $spec $micro $outsidegoodscutoff $estdir > 2_estimatessave_${JOB_ID}_${SGE_TASK_ID}.log 2>&1

# Both base and residualized instrument
	estdir="8"
	stata-se do 1_estimatessave.do $source $pmodule $year $freq $spec $micro $outsidegoodscutoff $estdir > 2_estimatessave_${JOB_ID}_${SGE_TASK_ID}.log 2>&1

# Main instrument with residualized instrument observations
	estdir="9"
	stata-se do 1_estimatessave.do $source $pmodule $year $freq $spec $micro $outsidegoodscutoff $estdir > 2_estimatessave_${JOB_ID}_${SGE_TASK_ID}.log 2>&1
  
#-------------------------------------------------
    rm 2_estimatessave_${JOB_ID}_${SGE_TASK_ID}.log

