 *===========================================================================================
*** 1_availability_modbymod.do
*** 	this code makes an annual store-level sales datasets for each module to be used to study availability and pricing 
*==========================================================================================

	args pmodule year overwrite

	if "`pmodule'"=="" {
		local pmodule=1203 
		local year = 2012
		local overwrite = 1		// flag indicating to NOT check whether file has already been created and create dataset anyway
	}
	
	foreach arg in  pmodule year overwrite {
		global `arg' "``arg''"
	}
		

*Set project directories	

	do ../../SetFilePaths.do
	
	global currentstep "$terminal/4_postestimation_analysis"

*Set-up standard directories	
	global data "$currentstep/Data"	
	global output "$currentstep/Output"
	global logs "$currentstep/Logs"
	global data_0 "${currentstep}/../0_dataimport/STATAData"

*Directory to store module-level datasets
	capture mkdir "$data/module_level"
	global outputdata "$data/module_level"
	
*==================================================================================================
*======================================================================================================

	cap prog drop main
	prog define main

		cap noisily confirm file ${outputdata}/store_module${pmodule}_${year}_data.dta
		if "${overwrite}"=="0" & _rc == 0 {
			di "dataset already exists for module -- ${pmodule}"
			error
		}	
		importandmerge
			
	end
	
*==================================================================================================*
*	Subprogram to import RMS data and merge with markets, products and instruments
*==================================================================================================*
if 1==1{
	cap prog drop importandmerge
	prog define importandmerge	
	if 1==1{
		di "Module -- ${pmodule}; Year -- ${year}"	
			capture noisily use year store_code_uc unitvalue value productid using ${data_0}/store_month_product/month_${pmodule}_${year}_productlevel.dta, clear
				// created by /0_dataimport/Code/1c_RMS_datasetup_v[].do

			if _rc!=0 error _rc  // data set doesn't exist
			
				keep if year==${year}
			
			di "Collapse to annual frequency"
				sort store_code_uc productid
				foreach v in unitvalue value {
					drop if ln(`v')==.
				}
				foreach v in unitvalue value {
					rename `v' old
					by store_code_uc productid: gen `v' = sum(old)
					drop old
				}
				by store_code_uc productid: keep if _n==_N
					
			di "Merge in brand id"
				merge m:1 productid using ${data_0}/RMSproductid_bymodule/RMSproductids_${pmodule}.dta, keep(1 3) keepusing(brand)
						// created in 0_dataimport/0c_createproductids_v[].do
					tab _merge
					keep if _merge==3
					drop _merge

			di "Rename variables"	
				rename unitvalue x
				rename value vjt
				rename productid prodid
				rename brand brandid
				keep store_code_uc prodid brandid x vjt
				
			save ${outputdata}/store_module${pmodule}_${year}_data.dta, replace
										
	}
	end
	
}
*==================================================================================================
**** Run programs and reset directory
	cd "${programs}"
	main
	cd "${programs}"

*==================================================================================================
