#!/bin/bash
#$ -N step4_2_robust
#$ -P real_handbury_team
#$ -t 1-100:1
#$ -l m_mem_free=2G
#$ -q all.q
#$ -j y

	market="cbsa" 
	year=2012
	source="matlab"
	freq="month"
	spec="_nl"
	micro="2" 
	outsidegoodscutoff="60"
	estdir=1
	incgrp="det"
	pmodule=0
	channel="0"
	nooverwrite="1"
	
	sampleV="_v$SGE_TASK_ID"
	
# OG 40
	estdir="2"
    outsidegoodscutoff="40"
	stata-se do 2_moduleindex_allmods.do $market $year $source $freq $spec $micro $outsidegoodscutoff $estdir _limit50 $incgrp $sampleV $pmodule $channel $nooverwrite > /dev/null 2>&1  
	outsidegoodscutoff="60"

# OG 80
	estdir="3"
	outsidegoodscutoff="80"
	stata-se do 2_moduleindex_allmods.do $market $year $source $freq $spec $micro $outsidegoodscutoff $estdir _limit50 $incgrp $sampleV $pmodule $channel $nooverwrite > /dev/null 2>&1  
	outsidegoodscutoff="60"

# Outside good market share cut 1%
	estdir="4"
	stata-se do 2_moduleindex_allmods.do $market $year $source $freq $spec $micro $outsidegoodscutoff $estdir _limit50 $incgrp $sampleV $pmodule $channel $nooverwrite > /dev/null 2>&1  

# Quarterly data
	estdir="5"
	freq="quarter"
	stata-se do 2_moduleindex_allmods.do $market $year $source $freq $spec $micro $outsidegoodscutoff $estdir _limit50 $incgrp $sampleV $pmodule $channel $nooverwrite > /dev/null 2>&1  
	freq="month" 
	
# residualized instruments
	estdir="6"
	stata-se do 2_moduleindex_allmods.do $market $year $source $freq $spec $micro $outsidegoodscutoff $estdir _limit50 $incgrp $sampleV $pmodule $channel $nooverwrite > /dev/null 2>&1  	