#!/bin/bash
#$ -N step4_3_robust
#$ -P real_handbury_team
#$ -l m_mem_free=30G
#$ -q short.q
#$ -j y
#$ -t 1-100:1

	market="cbsa"
    year="2012"
    source="matlab"
	freq="month"
	spec="_nl"
	micro="2" 
	outsidegoodscutoff="60"
    estdir=1
    test="0"
	incgrp="det"
	channel="0"
	cd ../../4_postestimation_analysis/Code
    
    sampleV="_v$SGE_TASK_ID"


# OG 40
	estdir="2"
    outsidegoodscutoff="40"
	stata-se do 3_aggindex.do $market $year $source $freq $spec $micro $outsidegoodscutoff $estdir $test _limit50 $incgrp $sampleV $channel > /dev/null 2>&1
	outsidegoodscutoff="60"

# OG 80
	estdir="3"
	outsidegoodscutoff="80"
	stata-se do 3_aggindex.do $market $year $source $freq $spec $micro $outsidegoodscutoff $estdir $test _limit50 $incgrp $sampleV $channel > /dev/null 2>&1
	outsidegoodscutoff="60"

# Outside good market share cut 1%
	estdir="4"
	stata-se do 3_aggindex.do $market $year $source $freq $spec $micro $outsidegoodscutoff $estdir $test _limit50 $incgrp $sampleV $channel > /dev/null 2>&1
	
# Quarterly data
	estdir="5"
	freq="quarter"
	stata-se do 3_aggindex.do $market $year $source $freq $spec $micro $outsidegoodscutoff $estdir $test _limit50 $incgrp $sampleV $channel > /dev/null 2>&1
	freq="month" 
	
# residualized instruments
	estdir="6"
	stata-se do 3_aggindex.do $market $year $source $freq $spec $micro $outsidegoodscutoff $estdir $test _limit50 $incgrp $sampleV $channel > /dev/null 2>&1