#!/bin/bash
#$ -N step4_4_robust
#$ -P real_handbury_team
#$ -l m_mem_free=50G
#$ -q all.q
#$ -j y

#baseline specifications (to be altered below for various robustness specs)
	market="cbsa"	
    year="2012"
    source="matlab"
	freq="month"
	spec="_nl"
	micro="2" 
	outsidegoodscutoff="60"
    estdir=1
	test="0"
	incgrp="det"
	channel="0"
		
    cd ../../4_postestimation_analysis/Code
 
	
# OG 40
	estdir="2"
    outsidegoodscutoff="40"
	stata-se -b do 4_indexcomparison_v11.do $market $year $source $freq $spec $micro $outsidegoodscutoff $estdir $test _limit50 $incgrp $channel 
	outsidegoodscutoff="60"

# OG 80
	estdir="3"
	outsidegoodscutoff="80"
	stata-se -b do 4_indexcomparison_v11.do $market $year $source $freq $spec $micro $outsidegoodscutoff $estdir $test _limit50 $incgrp $channel 
	outsidegoodscutoff="60"

# Outside good market share cut 1%
	estdir="4"
	stata-se -b do 4_indexcomparison_v11.do $market $year $source $freq $spec $micro $outsidegoodscutoff $estdir $test _limit50 $incgrp $channel 
	
# Quarterly data
	estdir="5"
	freq="quarter"
	stata-se -b do 4_indexcomparison_v11.do $market $year $source $freq $spec $micro $outsidegoodscutoff $estdir $test _limit50 $incgrp $channel 
	freq="month" 
	
# residualized instruments
	estdir="6"
	stata-se -b do 4_indexcomparison_v11.do $market $year $source $freq $spec $micro $outsidegoodscutoff $estdir $test _limit50 $incgrp $channel 